'Oom010 (11/18/2001 8:36:02 am)'.!


Object subclass: #OomHtmlReportWriter
	instanceVariableNames: 'name categories filter header footer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-System-Support'!
!OomHtmlReportWriter commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomHtmlReportWriter methodsFor: 'accessing'!
categories
	^categories! !

!OomHtmlReportWriter methodsFor: 'accessing'!
filter
	^filter! !

!OomHtmlReportWriter methodsFor: 'accessing'!
footer
	^footer! !

!OomHtmlReportWriter methodsFor: 'accessing'!
footer: aString 
	footer := aString asString! !

!OomHtmlReportWriter methodsFor: 'accessing'!
header
	^header! !

!OomHtmlReportWriter methodsFor: 'accessing'!
header: aString 
	header := aString asString! !

!OomHtmlReportWriter methodsFor: 'accessing'!
name
	^name! !

!OomHtmlReportWriter methodsFor: 'accessing'!
name: nameString categories: stringArray filter: filterBlock 
	name := nameString asString.
	categories := (stringArray collect: [:each | each asString]) asArray.
	filter := filterBlock.
	^self! !


!OomHtmlReportWriter methodsFor: 'classes'!
allClassNames
	^self allClasses collect: [:each | each name]! !

!OomHtmlReportWriter methodsFor: 'classes'!
allClasses
	| rootClasses allClasses blockClosure |
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	blockClosure := [:each | ((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: [allClasses add: each]].
	rootClasses
		do: 
			[:root | 
			blockClosure value: root.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each]]].
	^allClasses asArray! !

!OomHtmlReportWriter methodsFor: 'classes'!
allNumberOfClasses
	^self allClasses size! !

!OomHtmlReportWriter methodsFor: 'classes'!
classNames
	^self classes collect: [:each | each name]! !

!OomHtmlReportWriter methodsFor: 'classes' stamp: 'nishis 11/14/1998 13:02'!
classes
	| blockContext rootClasses allClasses patterns |
	self categories isNil ifTrue: [^Array new].
	blockContext := 
			[:each :classes | 
			((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: 
					[patterns := self categories select: [:pattern | self class stringMatch: each category asString and: pattern].
					(patterns isEmpty not and: [self filter value: each])
						ifTrue: [classes add: each]]].
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	rootClasses
		do: 
			[:root | 
			blockContext value: root value: allClasses.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockContext value: each value: allClasses]]].
	^allClasses asArray! !

!OomHtmlReportWriter methodsFor: 'classes'!
numberOfClasses
	^self classes size! !


!OomHtmlReportWriter methodsFor: 'messages'!
messages
	| instanceMessages classMessages |
	instanceMessages := Set new.
	classMessages := Set new.
	self classes
		do: 
			[:each | 
			instanceMessages addAll: each selectors.
			classMessages addAll: each class selectors].
	instanceMessages := instanceMessages asSortedCollection.
	classMessages := classMessages asSortedCollection.
	^Array with: instanceMessages with: classMessages! !

!OomHtmlReportWriter methodsFor: 'messages'!
numberOfMessages
	^self messages collect: [:each | each size]! !


!OomHtmlReportWriter methodsFor: 'methods'!
methods
	| instanceMethods classMethods |
	instanceMethods := Bag new.
	classMethods := Bag new.
	self classes
		do: 
			[:each | 
			instanceMethods addAll: each selectors.
			classMethods addAll: each class selectors].
	instanceMethods := instanceMethods asSortedCollection.
	classMethods := classMethods asSortedCollection.
	^Array with: instanceMethods with: classMethods! !

!OomHtmlReportWriter methodsFor: 'methods'!
numberOfMethods
	^self methods collect: [:each | each size]! !


!OomHtmlReportWriter methodsFor: 'steps' stamp: 'nishis 3/30/98 22:33'!
getchar: aStream 
	| char |
	aStream atEnd
		ifTrue: [char := nil]
		ifFalse: 
			[char := aStream next.
			char = Character linefeed
				ifTrue: [char := Character cr]
				ifFalse: [char = Character cr ifTrue: [aStream peek = Character linefeed ifTrue: [aStream next]]]].
	^char! !

!OomHtmlReportWriter methodsFor: 'steps'!
getline: aStream 
	| stream char |
	stream := WriteStream on: (String new: 128).
	char := self getchar: aStream.
	[char notNil and: [char ~= Character cr]]
		whileTrue: 
			[stream nextPut: char.
			char := self getchar: aStream].
	(char notNil and: [char = Character cr])
		ifTrue: [stream nextPut: char].
	^stream contents! !

!OomHtmlReportWriter methodsFor: 'steps'!
numberOfSteps
	| array |
	array := self steps.
	^array first! !

!OomHtmlReportWriter methodsFor: 'steps'!
steps
	| aDictionary iTotal cTotal iCount cCount |
	aDictionary := Dictionary new.
	iTotal := 0.
	cTotal := 0.
	self classes
		do: 
			[:each | 
			iCount := 0.
			cCount := 0.
			each selectors do: [:selector | iCount := iCount + (self steps: each selector: selector)].
			each class selectors do: [:selector | cCount := cCount + (self steps: each class selector: selector)].
			aDictionary add: each -> (Array with: iCount with: cCount).
			iTotal := iTotal + iCount.
			cTotal := cTotal + cCount].
	^Array with: (Array with: iTotal with: cTotal)
		with: aDictionary! !

!OomHtmlReportWriter methodsFor: 'steps'!
steps: aClass selector: aSelector 
	| count stream line |
	count := 0.
	Cursor read showWhile: [stream := ReadStream on: (aClass sourceCodeAt: aSelector)].
	[stream atEnd]
		whileFalse: 
			[line := self getline: stream.
			count := count + 1 + (line size // 60)].
	^count! !


!OomHtmlReportWriter methodsFor: 'reporting' stamp: 'nishis 6/28/1998 05:18'!
report
	| reportingClasses separatorString saveDirectory baseString fileNames fileNo fileName writeStream filename file |
	reportingClasses := self classes.
	reportingClasses isEmpty ifTrue: [^nil].
	reportingClasses size > 1
		ifTrue: [Transcript cr; cr; show: self name , ': reporting ' , reportingClasses size printString , ' classes ...']
		ifFalse: [Transcript cr; cr; show: self name , ': reporting ' , reportingClasses size printString , ' class ...'].
	separatorString := String with: FileDirectory pathNameDelimiter.
	saveDirectory := FileDirectory on: self class defaultDirectoryName , self name.
	(saveDirectory containingDirectory includesKey: saveDirectory pathParts last)
		ifTrue: [saveDirectory fileNames
				do: 
					[:each | 
					filename := self class defaultDirectoryName , self name , separatorString , each.
					(FileDirectory on: self class defaultDirectoryName, self name) 						deleteFileNamed: each 
						ifAbsent: []]]
		ifFalse: [saveDirectory containingDirectory 
					createDirectory: saveDirectory pathParts last].
	baseString := String new.
	8 - self reportPrefix size timesRepeat: [baseString := baseString , '0'].
	fileNames := OrderedCollection new.
	fileNo := 1.
	reportingClasses
		do: 
			[:each | 
			fileNames add: (self filename: fileNo).
			fileNo := fileNo + 1].
	reportingClasses with: fileNames
		do: 
			[:each :it | 
			filename := self class defaultDirectoryName , self name.
			filename := filename , separatorString , it.
			file := FileStream fileNamed: filename.
			self
				privateReportClass: each
				into: file
				classes: reportingClasses
				files: fileNames.
			file close.
			Transcript cr; show: each name , ' -> ' , it].
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , (self filename: 0).
	Transcript cr; show: self name , ' -> ' , (self filename: 0).
	writeStream := FileStream fileNamed: fileName.
	self
		privateReportTable: reportingClasses
		into: writeStream
		files: fileNames.
	writeStream close.
	Transcript cr; show: '... done at ' , Date today printString , ' ' , Time now printString! !

!OomHtmlReportWriter methodsFor: 'reporting'!
reportPrefix
	^'Rpt' copy! !


!OomHtmlReportWriter methodsFor: 'filename'!
filename: fileNo 
	"OomHtmlReportWriter new filename: 123."

	| extensionString baseString aStream |
	extensionString := '.htm'.
	baseString := String new.
	8 - self reportPrefix size timesRepeat: [baseString := baseString , '0'].
	aStream := WriteStream on: (String new: 12).
	aStream nextPutAll: self reportPrefix.
	baseString size - fileNo printString size timesRepeat: [aStream nextPutAll: '0'].
	aStream nextPutAll: fileNo printString.
	aStream nextPutAll: extensionString.
	^aStream contents! !


!OomHtmlReportWriter methodsFor: 'private'!
privateReportClass: aClass into: aStream 
	aStream nextPutAll: '<H2>'.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream cr.
	aClass comment asString
		do: 
			[:char | 
			char = Character cr ifTrue: [aStream nextPutAll: '<BR>'].
			aStream nextPut: char].
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportClass: aClass into: aStream classes: classCollection files: fileNames 
	self privateReportHeader: aClass name asString into: aStream.
	aStream cr.
	self privateReportClass: aClass into: aStream.
	aStream cr.
	self
		privateReportSuperclass: aClass
		into: aStream
		classes: classCollection
		files: fileNames.
	aStream cr.
	self
		privateReportInstanceVariables: aClass
		into: aStream
		label: 'instance variables'.
	aStream cr.
	self
		privateReportInstanceVariables: aClass class
		into: aStream
		label: 'class instance variables'.
	aStream cr.
	self privateReportClassVariables: aClass into: aStream.
	aStream cr.
	self privateReportPoolVariables: aClass into: aStream.
	aStream cr.
	self
		privateReportMethods: aClass
		into: aStream
		label: 'instance methods'.
	aStream cr.
	self
		privateReportMethods: aClass class
		into: aStream
		label: 'class methods'.
	aStream cr.
	self privateReportFooter: aClass name asString into: aStream.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportClassVariables: aClass into: aStream 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>class variabels:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass classPool keys asSortedCollection
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: each asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportFooter: aString into: aStream 
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr.
	aStream nextPutAll: '<A HREF="'.
	aStream nextPutAll: (self filename: 0).
	aStream nextPutAll: '"><B>index</B></A><BR>'.
	aStream cr.
	(self footer isNil or: [self footer isEmpty])
		ifFalse: 
			[aStream nextPutAll: self footer.
			aStream nextPutAll: '<BR>'.
			aStream cr].
	aStream cr.
	aStream nextPutAll: '</BODY>'.
	aStream cr.
	aStream nextPutAll: '</HTML>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportHeader: aString into: aStream 
	aStream nextPutAll: '<HTML>'.
	aStream cr.
	aStream nextPutAll: '<HEAD>'.
	aStream cr.
	aStream nextPutAll: '<TITLE>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: '</TITLE>'.
	aStream cr.
	aStream nextPutAll: '</HEAD>'.
	aStream cr.
	aStream nextPutAll: '<BODY>'.
	aStream cr.
	aStream cr.
	(self header isNil or: [self header isEmpty])
		ifFalse: 
			[aStream nextPutAll: self header.
			aStream nextPutAll: '<BR>'.
			aStream cr].
	aStream nextPutAll: '<A HREF="'.
	aStream nextPutAll: (self filename: 0).
	aStream nextPutAll: '"><B>index</B></A><BR>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportInstanceVariables: aClass into: aStream label: aString 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: ':</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass instVarNames
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: each asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private' stamp: 'nishis 7/20/1998 03:16'!
privateReportMethod: aClass selector: aSelector into: aStream 
	| source parser pattern collection string comments |
	source := aClass sourceCodeAt: aSelector.
	parser := aClass parserClass new.
	parser parseSelector: source.
	pattern := source copyFrom: 1 to: parser endOfLastToken.
	[pattern last isSeparator]
		whileTrue: [pattern := pattern copyFrom: 1 to: pattern size - 1].
	aSelector numArgs = 0
		ifTrue: 
			[aStream nextPutAll: '<B>'.
			aStream nextPutAll: pattern asString.
			aStream nextPutAll: '</B>']
		ifFalse: 
			[collection := Scanner new scanTokens: pattern.
			1
				to: collection size
				by: 2
				do: 
					[:index | 
					index > 1 ifTrue: [aStream space].
					aStream nextPutAll: '<B>'.
					aStream nextPutAll: (collection at: index).
					aStream nextPutAll: '</B>'.
					aStream space.
					aStream nextPutAll: (collection at: index + 1 ifAbsent: [String new])]].
	string := (aClass organization categoryOfElement: aSelector) asString.
	aStream nextPutAll: ' <I>[' , string , ']</I>'.
	aStream nextPutAll: '<BR>'.
	comments := Parser new parseMethodComment: source setPattern: [:x | ].
	comments isEmpty
		ifFalse: 
			[aStream cr.
			comments first asString
				do: 
					[:char | 
					char = Character cr ifTrue: [aStream nextPutAll: '<BR>'].
					aStream nextPut: char]].
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportMethods: aClass into: aStream label: aString 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: ':</I>'.
	aStream cr.
	aStream nextPutAll: '<OL>'.
	aClass selectors asSortedCollection
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI>'.
			self
				privateReportMethod: aClass
				selector: each asSymbol
				into: aStream].
	aStream cr.
	aStream nextPutAll: '</OL>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportPoolVariables: aClass into: aStream 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>pool variabels:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass sharedPools
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: (Smalltalk keyAtValue: each) asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportSuperclass: aClass into: aStream classes: classCollection files: fileNames 
	| index |
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>superclass:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	aStream nextPutAll: '<LI><B>'.
	index := classCollection findFirst: [:each | each = aClass superclass].
	index = 0
		ifTrue: [aStream nextPutAll: aClass superclass name asString]
		ifFalse: 
			[aStream nextPutAll: '<A HREF="'.
			aStream nextPutAll: (fileNames at: index) asString.
			aStream nextPutAll: '">'.
			aStream nextPutAll: aClass superclass name asString.
			aStream nextPutAll: '</A>'].
	aStream nextPutAll: '</B>'.
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private'!
privateReportTable: allClasses into: aStream files: fileNames 
	| collection key value array dictionary |
	collection := SortedCollection new: allClasses size.
	collection sortBlock: [:x :y | x key name < y key name].
	allClasses with: fileNames
		do: 
			[:aClass :fileName | 
			key := aClass.
			value := fileName.
			collection add: key -> value].
	self privateReportHeader: self name asString into: aStream.
	aStream cr.
	aStream nextPutAll: '<H2>'.
	aStream nextPutAll: self name asString.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: 'classes: '.
	aStream nextPutAll: allClasses size printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	aStream nextPutAll: 'instance methods & class methods: '.
	Cursor wait showWhile: [array := self numberOfMethods].
	aStream nextPutAll: array first printString.
	aStream nextPutAll: ' & '.
	aStream nextPutAll: array last printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	Cursor wait
		showWhile: 
			[array := self steps.
			dictionary := array last].
	aStream nextPutAll: 'instance method steps & class method steps: '.
	aStream nextPutAll: array first first printString.
	aStream nextPutAll: ' & '.
	aStream nextPutAll: array first last printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	collection
		do: 
			[:association | 
			aStream nextPutAll: '<LI><A HREF="'.
			aStream nextPutAll: association value asString.
			aStream nextPutAll: '"><STRONG>'.
			aStream nextPutAll: association key name asString.
			aStream nextPutAll: '</STRONG></A>'.
			array := dictionary at: association key ifAbsent: [nil].
			array isNil
				ifFalse: 
					[aStream nextPutAll: ' (steps: '.
					aStream nextPutAll: array first printString.
					aStream nextPutAll: ' & '.
					aStream nextPutAll: array last printString.
					aStream nextPutAll: ')'].
			aStream cr].
	aStream nextPutAll: '</UL>'.
	aStream cr.
	self privateReportFooter: self name asString into: aStream.
	aStream cr.
	^aStream! !

!OomHtmlReportWriter methodsFor: 'private' stamp: 'nishis 3/30/98 17:58'!
privateValues
	^ self class privateValues
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomHtmlReportWriter class
	instanceVariableNames: ''!

!OomHtmlReportWriter class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomHtmlReportWriter class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomHtmlReportWriter class methodsFor: 'copyright'!
version
	^'010'! !


!OomHtmlReportWriter class methodsFor: 'instance creation'!
name: nameString categories: symbolArray 
	^super new
		name: nameString
		categories: symbolArray
		filter: [:aClass | true]! !

!OomHtmlReportWriter class methodsFor: 'instance creation'!
name: nameString categories: stringArray filter: filterBlock 
	^super new
		name: nameString
		categories: stringArray
		filter: filterBlock! !


!OomHtmlReportWriter class methodsFor: 'utilities' stamp: 'nishis 3/30/98 23:24'!
defaultDirectoryName
	"OomHtmlReportWriter defaultDirectoryName."

	| directoryName |
	directoryName := FileDirectory default pathName.
	directoryName last = FileDirectory pathNameDelimiter ifFalse: [directoryName := directoryName , (String with: FileDirectory pathNameDelimiter)].
	^directoryName! !

!OomHtmlReportWriter class methodsFor: 'utilities'!
separate: separateCollection dividers: dividerCollection 
	"OomHtmlReportWriter separate: #(a b c d e f g h) dividers: #(d f)."

	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(dividerCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!OomHtmlReportWriter class methodsFor: 'utilities' stamp: 'nishis 3/30/98 22:35'!
separators
	"OomHtmlReportWriter separators."

	| stream |
	stream := WriteStream on: (String new: 4).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	^stream contents! !

!OomHtmlReportWriter class methodsFor: 'utilities'!
stringMatch: string and: pattern 
	"OomHtmlReportWriter stringMatch: ' Aoki' and: 'Ju*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!OomHtmlReportWriter class methodsFor: 'utilities'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !


!OomHtmlReportWriter class methodsFor: 'examples' stamp: 'nishis 3/31/98 01:18'!
example1
	"OomHtmlReportWriter example1."

	| htmlReportWriter |
	htmlReportWriter := OomHtmlReportWriter
				name: 'Report01'
				categories: #('Goodies-*' 'Numeric-Numbers' 'Graphics-Primitives')
				filter: [:aClass | aClass = OomHtmlReportWriter or: [aClass withAllSuperclasses includes: Number]].
	htmlReportWriter header: 'This is a header. System name is recommended as header.'.
	htmlReportWriter footer: 'This is a footer. Copyright or E-Mail address is recommended as footer.'.
	htmlReportWriter report.
	^htmlReportWriter! !

!OomHtmlReportWriter class methodsFor: 'examples' stamp: 'nishis 3/31/98 01:16'!
example2
	"OomHtmlReportWriter example2."

	| htmlReportWriter |
	htmlReportWriter := OomHtmlReportWriter
				name: 'Report01'
				categories: #('Goodies-*' 'Numeric-Numbers' 'Graphics-Primitives')
				filter: [:aClass | aClass = OomHtmlReportWriter or: [aClass withAllSuperclasses includes: Number]].
	Transcript cr; show: 'classes: '.
	Transcript space; show: htmlReportWriter numberOfClasses printString.
	Transcript cr; show: 'instance messages & class messages: '.
	Transcript space; show: htmlReportWriter numberOfMessages printString.
	Transcript cr; show: 'instance methods & class methods: '.
	Transcript space; show: htmlReportWriter numberOfMethods printString.
	Transcript cr; show: 'instance method steps & class method steps: '.
	Transcript space; show: htmlReportWriter numberOfSteps printString.
	^htmlReportWriter! !


!OomHtmlReportWriter class methodsFor: 'private'!
privateValues
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: Smalltalk size.
	Smalltalk do: [:value | anOrderedCollection add: value].
	^anOrderedCollection! !
