'Oom010 (11/18/2001 8:36:03 am)'.!


StringHolder subclass: #OomMultiSelectionInList
	instanceVariableNames: 'list listIndex listSelections '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Pluggable-Support'!
!OomMultiSelectionInList commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomMultiSelectionInList methodsFor: 'initialization-release' stamp: 'nishis 7/25/1998 00:14'!
initialize
	list := OrderedCollection new.
	listSelections := Array new: list size withAll: false.
	listIndex := 0.! !


!OomMultiSelectionInList methodsFor: 'adding' stamp: 'nishis 7/21/1998 19:47'!
add: anItem 
	self addItem: anItem.
	listSelections := Array new: list size withAll: false.
	^anItem! !

!OomMultiSelectionInList methodsFor: 'adding' stamp: 'nishis 7/22/1998 22:18'!
addAll: aCollection 
	aCollection do: [:each | self addItem: each].
	listSelections := Array new: list size withAll: false.
	^aCollection! !


!OomMultiSelectionInList methodsFor: 'selections in list' stamp: 'nishis 7/21/1998 22:58'!
selections
	| items |
	items := OrderedCollection new.
	1 to: listSelections size do: 
		[:i | (listSelections at: i) ifTrue: [items add: (list at: i)]].
	^items! !

!OomMultiSelectionInList methodsFor: 'selections in list' stamp: 'nishis 11/7/1998 00:51'!
selections: aCollection
	Cursor execute showWhile: 
		[1 to: list size do: 
			[:i | 
			(aCollection includes: (list at: i)) 
				ifTrue: [listSelections at: i put: true]
				ifFalse: [listSelections at: i put: false]].
		self changed: #listIndex.
		self changed: #contents].
	^self selections! !


!OomMultiSelectionInList methodsFor: 'menu actions' stamp: 'nishis 7/25/1998 04:40'!
inspectThem
	self selections inspect! !

!OomMultiSelectionInList methodsFor: 'menu actions' stamp: 'nishis 7/25/1998 00:29'!
menu
	^[SelectionMenu 
		labels: 'inspect'
		lines: #()
		selections: #(inspectThem)]
! !


!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/21/1998 19:06'!
list
	^ list! !

!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/22/1998 22:18'!
list: aCollection
	list := OrderedCollection new: aCollection size.
	self addAll: aCollection.
	listIndex := 0.
	self changed: #list.
	^list! !

!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/21/1998 19:06'!
listIndex
	^ listIndex! !

!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/21/1998 19:53'!
listSelectionAt: index
	"self debug: index."
	^ listSelections at: index! !

!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/21/1998 19:06'!
listSelectionAt: index put: value
	listIndex _ 0.
	^ listSelections at: index put: value! !

!OomMultiSelectionInList methodsFor: 'viewing access' stamp: 'nishis 7/25/1998 00:15'!
toggleListIndex: newListIndex
	(listIndex ~= 0 and: [listIndex ~= newListIndex]) ifTrue:
		[listSelections at: listIndex put: false].  "turn off old selection if was on"
	newListIndex = 0 
		ifTrue: [listIndex := 0]
		ifFalse: [
			listSelections at: newListIndex  "Complement selection state"
					put: (listSelections at: newListIndex) not.
			listIndex := (listSelections at: newListIndex)
				ifTrue: [newListIndex]  "and set selection index accordingly"
				ifFalse: [0]].
	self changed: #listIndex.
	self changed: #contents! !


!OomMultiSelectionInList methodsFor: 'private' stamp: 'nishis 7/21/1998 19:37'!
addItem: item 
	list addLast: item! !

!OomMultiSelectionInList methodsFor: 'private' stamp: 'nishis 11/14/1998 12:45'!
debug: anObject
	"Transcript cr; show: anObject printString"! !

!OomMultiSelectionInList methodsFor: 'private' stamp: 'nishis 7/22/1998 22:19'!
listSelections
	^listSelections! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMultiSelectionInList class
	instanceVariableNames: ''!

!OomMultiSelectionInList class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomMultiSelectionInList class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMultiSelectionInList class methodsFor: 'copyright'!
version
	^'010'! !


!OomMultiSelectionInList class methodsFor: 'instance creation' stamp: 'nishis 11/14/1998 12:58'!
open: aList name: aString 
	| topView aListView |
	World ifNotNil: [^ self openAsMorph: aList name: aString].

	topView := (StandardSystemView new) model: aList.
	topView label: aString.
	topView minimumSize: 180 @ 120.
	topView borderWidth: 1.
	aListView := OomMultiSelectionInListView on: aList menu: #menu.
	aListView controller menuHolder: aList menu.
	aListView controller performer: aList.
	aListView window: (0 @ 0 extent: 180 @ 100).
	topView addSubView: aListView.
	topView resizeInitially.
	topView resizeTo: (topView insetDisplayBox origin extent: topView minimumSize).
	topView controller status: #open.
	ScheduledControllers scheduleActive: topView controller! !

!OomMultiSelectionInList class methodsFor: 'instance creation' stamp: 'nishis 7/25/1998 00:33'!
openAsMorph: aChangeList name: labelString 
	| window listView |
	
	window := ((Smalltalk at: #SystemWindow ifAbsent: [^ self]) labelled: labelString) model: aChangeList.

	window addMorph: (listView _ (Smalltalk at:  #PluggableListMorph) on: aChangeList list: #list
		selected: #listIndex changeSelected: #toggleListIndex:
		menu: #changeListMenu: keystroke: #messageListKey:from:)
		frame: (0@0 corner: 1@0.3).

	listView controller: PluggableListControllerOfMany new.

	window addMorph: ((Smalltalk at: #AcceptableCleanTextMorph) on: aChangeList 
			text: #contents accept: #contents:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (0@0.3 corner: 1@1).
	^ window openInWorld! !

!OomMultiSelectionInList class methodsFor: 'instance creation' stamp: 'nishis 7/25/1998 00:00'!
with: aCollection
	| aList |
	aList := self new.
	aList addAll: aCollection.
	^aList! !


!OomMultiSelectionInList class methodsFor: 'examples' stamp: 'nishis 7/25/1998 01:04'!
example1 
	"OomMultiSelectionInList example1."

	| aList string collection |
	string := 'test'.
	aList := self new.
	collection := SortedCollection new.
	Smalltalk allBehaviorsDo: [:each | each isMeta not ifTrue: [collection add: each name]].
	aList addAll: collection.

	self open: aList name: string! !
