'Oom010 (11/18/2001 8:36:04 am)'.!


OomController subclass: #OomAokiMetricsController
	instanceVariableNames: ''
	classVariableNames: 'FrameCornerCursor FrameOriginCursor '
	poolDictionaries: ''
	category: 'Oom-Metrics-Tool'!
!OomAokiMetricsController commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomAokiMetricsController methodsFor: 'basic control sequence' stamp: 'nishis 7/23/1998 00:20'!
controlTerminate
	Cursor normal show! !


!OomAokiMetricsController methodsFor: 'control defaults' stamp: 'nishis 7/23/1998 00:20'!
controlActivity
	(self sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(self sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	(self sensor keyboardPressed and: [self viewHasCursor])
		ifTrue: [^self keyboardActivity].
	self idleActivity! !

!OomAokiMetricsController methodsFor: 'control defaults' stamp: 'nishis 7/23/1998 22:50'!
idleActivity
	| point mode bool box order interval cursor |
	"self poll."
	cursor := Cursor currentCursor.
	point := self sensor cursorPoint - view insetDisplayBox origin.
	mode := self model currentMode.
	bool := false.
	mode = #HFRF
		ifTrue: 
			[box := 0 @ 0 extent: self model plateHFRF boundingBox extent.
			box := box translateBy: self view marginRectangle origin.
			bool := box containsPoint: point].
	mode = #PFRF
		ifTrue: 
			[box := 0 @ 0 extent: self model platePFRF boundingBox extent.
			box := box translateBy: self view marginRectangle origin.
			bool := box containsPoint: point].
	mode = #HFPF
		ifTrue: 
			[box := 0 @ 0 extent: self model plateHFPF boundingBox extent.
			box := box translateBy: self view marginRectangle origin.
			bool := box containsPoint: point].
	mode = #HFRFPF
		ifTrue: 
			[order := self model orderPlates.
			interval := self model plateInterval.
			box := 0 @ 0 extent: (self model platesHFRFPF at: order last) boundingBox extent.
			box := box translateBy: self view marginRectangle origin.
			box := box translateBy: (order last - 1 * interval) asPoint.
			bool := box containsPoint: point].
	bool
		ifTrue: [cursor = OomCursors crossCursor ifFalse: [OomCursors crossCursor show]]
		ifFalse: [cursor = Cursor normal ifFalse: [Cursor normal show]]! !

!OomAokiMetricsController methodsFor: 'control defaults' stamp: 'nishis 7/23/1998 00:21'!
keyboardActivity
"	self keyboardEvent: self sensor keyboardEvent"! !

!OomAokiMetricsController methodsFor: 'control defaults' stamp: 'nishis 7/23/1998 23:40'!
redButtonActivity
	| bool area point |
	bool := self holdFor: 300 whileDo: [self sensor anyButtonPressed].
	point := self sensor cursorPoint - view insetDisplayBox origin.
	bool
		ifTrue: [area := point extent: 1 @ 1]
		ifFalse: 
			[area := self view insetDisplayBox.
			area := self frameFromUser: area].
	self select: area! !

!OomAokiMetricsController methodsFor: 'control defaults' stamp: 'nishis 7/25/1998 01:56'!
yellowButtonActivity
	self controlTerminate.
	^super yellowButtonActivity! !


!OomAokiMetricsController methodsFor: 'selecting' stamp: 'nishis 7/23/1998 01:27'!
select: aRectangle 
	| box extent hf rf pf horizontal vertical all top array order interval num zeroPoint unityPoint mid min max |					
	zeroPoint := 0 @ 0.
	unityPoint := 1 @ 1.
	horizontal := [:rect :size | Array with: ((rect origin x / size x) asFloat roundTo: 0.01)
				with: ((rect corner x / size x) asFloat roundTo: 0.01)].
	vertical := [:rect :size | Array with: ((rect origin y / size y) asFloat roundTo: 0.01)
				with: ((rect corner y / size y) asFloat roundTo: 0.01)].
	all := [:rect :size | Array with: 0.0 with: 1.0].
	box := aRectangle translateBy: zeroPoint - self view marginRectangle origin.
	box := box insetBy: (zeroPoint corner: unityPoint).
	box area < 4 ifTrue: [box := box expandBy: 1].
	self model currentMode = #HFRF
		ifTrue: 
			[extent := self model plateHFRF boundingBox extent - (1 @ 1).
			box := box intersect: (zeroPoint extent: extent).
			hf := horizontal value: box value: extent.
			rf := vertical value: box value: extent.
			pf := all value: box value: extent].
	self model currentMode = #PFRF
		ifTrue: 
			[extent := self model platePFRF boundingBox extent - (1 @ 1).
			box := box intersect: (zeroPoint extent: extent).
			pf := horizontal value: box value: extent.
			rf := vertical value: box value: extent.
			hf := all value: box value: extent].
	self model currentMode = #HFPF
		ifTrue: 
			[extent := self model plateHFPF boundingBox extent - (1 @ 1).
			box := box intersect: (zeroPoint extent: extent).
			hf := horizontal value: box value: extent.
			pf := vertical value: box value: extent.
			rf := all value: box value: extent].
	self model currentMode = #HFRFPF
		ifTrue: 
			[order := self model orderPlates.
			interval := self model plateInterval.
			num := self model plateSize.
			extent := (self model platesHFRFPF at: order last) boundingBox extent - (1 @ 1).
			box := box translateBy: zeroPoint - (order last - 1 * interval) asPoint.
			(box intersects: (zeroPoint extent: extent))
				ifTrue: 
					[box := box intersect: (zeroPoint extent: extent).
					hf := horizontal value: box value: extent.
					rf := vertical value: box value: extent.
					pf := 
							[mid := order last - 1 / (num - 1).
							min := mid - (1 / (num - 1) / 2).
							max := mid + (1 / (num - 1) / 2).
							Array with: ((min max: 0) asFloat roundTo: 0.01)
								with: ((max min: 1) asFloat roundTo: 0.01)] value]
				ifFalse: 
					[box := box translateBy: (order last - 1 * interval) asPoint.
					top := nil.
					order
						reverseDo: 
							[:index | 
							extent := (self model platesHFRFPF at: index) boundingBox extent - (1 @ 1).
							(box intersects: ((index - 1 * interval) asPoint extent: extent))
								ifTrue: [top isNil ifTrue: [top := index]]].
					top notNil
						ifTrue: 
							[order add: (order remove: top).
							self model changed: #order].
					^self]].
	array := Array
				with: hf
				with: rf
				with: pf.
	self controlTerminate.
	self model showClasses: array! !


!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 01:18'!
frameCornerCursor
	FrameCornerCursor isNil ifTrue: [FrameCornerCursor := Cursor
				extent: 16@16 
				fromArray: #(
		2r0000000000000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0111111100000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0)
				offset: -7 @ -7].
	^FrameCornerCursor! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 01:14'!
frameFromUser
	"OomAokiMetricsController new frameFromUser."

	^self
		frameFromUser: Display boundingBox
		minSize: 0 @ 0
		maxSize: Display boundingBox extent
		frameGrid: 1 @ 1
		offsetPoint: 0 @ 0
		gridPhase: 0 @ 0! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 01:08'!
frameFromUser: boundingBox 
	"OomAokiMetricsController new 
	frameFromUser: (100 @ 100 extent: 200 @ 200)."

	^self
		frameFromUser: boundingBox
		minSize: 0 @ 0
		maxSize: boundingBox extent
		frameGrid: 1 @ 1
		offsetPoint: 0 @ 0
		gridPhase: 0 @ 0! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 23:15'!
frameFromUser: boundingBox minSize: minSize maxSize: maxSize 
	"OomAokiMetricsController new 
	frameFromUser: Display boundingBox
	minSize: 50@50 
	maxSize: 300@300."

	^self
		frameFromUser: boundingBox
		minSize: minSize
		maxSize: maxSize
		frameGrid: 1 @ 1
		offsetPoint: 0 @ 0
		gridPhase: 0 @ 0! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 23:15'!
frameFromUser: boundingBox minSize: minSize maxSize: maxSize frameGrid: frameGrid 
	"OomAokiMetricsController new 
	frameFromUser: Display boundingBox 
	minSize: 50@50 
	maxSize: 300@300 
	frameGrid: 20@20."

	^self
		frameFromUser: boundingBox
		minSize: minSize
		maxSize: maxSize
		frameGrid: frameGrid
		offsetPoint: 0 @ 0
		gridPhase: 0 @ 0! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 23:27'!
frameFromUser: boundingBox minSize: minSize maxSize: maxSize frameGrid: frameGrid offsetPoint: offsetPoint gridPhase: gridPhase 
	"OomAokiMetricsController new 
	frameFromUser: Display boundingBox 
	minSize: 50@50 
	maxSize: 300@300 
	frameGrid: 20@20 
	offsetPoint: 0 @ 0 
	gridPhase: 5@5."

	| frameRect saveCursor originPoint |
	frameRect := 0 @ 0 extent: minSize.
	saveCursor := Cursor currentCursor.
	self frameOriginCursor show.
	originPoint := self sensor cursorPoint.
	[originPoint = Sensor cursorPoint] whileTrue.
	frameRect := originPoint extent: frameRect extent.
	frameRect := self frameCornerCursor showWhile:
		[frameRect newRectFrom:
			[:f | f origin corner: (Sensor cursorPoint grid: frameGrid)]].
	saveCursor show.
	^frameRect translateBy: boundingBox origin negated! !

!OomAokiMetricsController methodsFor: 'framing' stamp: 'nishis 7/23/1998 18:48'!
frameOriginCursor
	FrameOriginCursor isNil ifTrue: [FrameOriginCursor := Cursor
				extent: 16@16 
				fromArray: #(
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000000000000
		2r0000000111111110
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000100000000
		2r0000000000000000
		2r0)
			offset: -7@-7].
	^FrameOriginCursor! !


!OomAokiMetricsController methodsFor: 'private' stamp: 'nishis 7/23/1998 00:25'!
holdFor: millisecondTime untilDo: aBlock 
	| timeLimit |
	timeLimit := Time millisecondClockValue + millisecondTime.
	[Time millisecondClockValue < timeLimit]
		whileTrue: 
			[aBlock value = true ifTrue: [^true].
			Processor yield].
	^false! !

!OomAokiMetricsController methodsFor: 'private' stamp: 'nishis 7/23/1998 00:25'!
holdFor: millisecondTime whileDo: aBlock 
	^self holdFor: millisecondTime untilDo: [aBlock value ~= true]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomAokiMetricsController class
	instanceVariableNames: ''!

!OomAokiMetricsController class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomAokiMetricsController class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomAokiMetricsController class methodsFor: 'copyright'!
version
	^'010'! !
