'Oom010 (11/18/2001 8:36:05 am)'.!


SequenceableCollection subclass: #OomSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Collections-Sequenceable'!
!OomSequence commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomSequence methodsFor: 'accessing'!
at: indexInteger 
	| count |
	count := 1.
	self do: 
		[:each | 
		indexInteger = count ifTrue: [^each].
		count := count + 1].
	^self subscriptOutOfBoundsError: indexInteger! !

!OomSequence methodsFor: 'accessing'!
at: indexInteger put: anObject 
	^self subclassResponsibility! !

!OomSequence methodsFor: 'accessing'!
size
	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^tally! !


!OomSequence methodsFor: 'adding'!
addAll: aCollection 
	aCollection do: [:each | self add: each]! !


!OomSequence methodsFor: 'copying'!
, aSequence 
	| newSequence |
	newSequence := self shallowCopy.
	aSequence do: [:each | newSequence add: each].
	^newSequence! !

!OomSequence methodsFor: 'copying'!
copyWith: newElement 
	| newSequence |
	newSequence := self shallowCopy.
	newSequence add: newElement.
	^newSequence! !

!OomSequence methodsFor: 'copying'!
copyWithout: oldElement 
	^self select: [:each | oldElement ~= each]! !

!OomSequence methodsFor: 'copying' stamp: 'nishis 7/30/1998 21:54'!
shallowCopy
	| newSequence |
	newSequence := self species new.
	self do: [:each | newSequence add: each].
	^newSequence! !


!OomSequence methodsFor: 'enumerating'!
collect: aBlock 
	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^newCollection! !

!OomSequence methodsFor: 'enumerating'!
findFirst: aBlock 
	| index |
	index := 1.
	self do: 
		[:each | 
		(aBlock value: each)
			ifTrue: [^index].
		index := index + 1].
	^0! !

!OomSequence methodsFor: 'enumerating'!
findLast: aBlock 
	| index |
	index := self size.
	self
		reverseDo: 
			[:each | 
			(aBlock value: each)
				ifTrue: [^index].
			index := index - 1].
	^0! !

!OomSequence methodsFor: 'enumerating'!
reverse
	| reverseSequence |
	reverseSequence := self species new.
	self reverseDo: [:each | reverseSequence add: each].
	^reverseSequence! !

!OomSequence methodsFor: 'enumerating'!
select: aBlock 
	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each)
			ifTrue: [newCollection add: each]].
	^newCollection! !


!OomSequence methodsFor: 'converting'!
asArray
	| anArray index |
	anArray := Array new: self size.
	index := 1.
	self do: 
		[:each | 
		anArray at: index put: each.
		index := index + 1].
	^anArray! !

!OomSequence methodsFor: 'converting'!
asBag
	| aBag |
	aBag := Bag new.
	self do: [:each | aBag add: each].
	^aBag! !

!OomSequence methodsFor: 'converting'!
asOrderedCollection
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	self do: [:each | anOrderedCollection addLast: each].
	^anOrderedCollection! !

!OomSequence methodsFor: 'converting'!
asSet
	| aSet |
	aSet := Set new.
	self do: [:each | aSet add: each].
	^aSet! !

!OomSequence methodsFor: 'converting'!
asSortedCollection
	| aSortedCollection |
	aSortedCollection := SortedCollection new.
	aSortedCollection addAll: self asArray.
	^aSortedCollection! !

!OomSequence methodsFor: 'converting'!
asSortedCollection: aBlock 
	| aSortedCollection |
	aSortedCollection := SortedCollection new.
	aSortedCollection sortBlock: aBlock.
	aSortedCollection addAll: self asArray.
	^aSortedCollection! !


!OomSequence methodsFor: 'arithmetic'!
* aSequence 
	^self compute: #* with: aSequence! !

!OomSequence methodsFor: 'arithmetic'!
+ aSequence 
	^self compute: #+ with: aSequence! !

!OomSequence methodsFor: 'arithmetic'!
- aSequence 
	^self compute: #- with: aSequence! !

!OomSequence methodsFor: 'arithmetic'!
/ aSequence 
	^self compute: #/ with: aSequence! !

!OomSequence methodsFor: 'arithmetic'!
// aSequence 
	^self compute: #// with: aSequence! !

!OomSequence methodsFor: 'arithmetic'!
compute: aSymbol with: aSequence 
	| array1 array2 newSequence |
	array1 := self asArray.
	(aSequence isKindOf: Number)
		ifTrue: [1 to: array1 size do: [:i | array1 at: i put: ((array1 at: i)
						perform: aSymbol with: aSequence)]]
		ifFalse: 
			[array2 := aSequence asArray.
			1 to: (array1 size min: array2 size)
				do: [:i | array1 at: i put: ((array1 at: i)
							perform: aSymbol with: (array2 at: i))]].
	newSequence := self species new.
	newSequence addAll: array1.
	^newSequence! !


!OomSequence methodsFor: 'private'!
subscriptOutOfBoundsError: index 
	^self error: 'subscript out of bounds: ' , index printString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomSequence class
	instanceVariableNames: ''!

!OomSequence class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomSequence class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomSequence class methodsFor: 'copyright'!
version
	^'010'! !


!OomSequence class methodsFor: 'list interface' stamp: 'nishis 7/30/1998 21:52'!
classOfFromList: className
	| aClass |
	((((className respondsTo: #asSymbol)
		and: [Smalltalk includesKey: className])
		and: [(aClass := Smalltalk at: className) isKindOf: Behavior])
		and: [aClass isMeta not])
		ifTrue: [^aClass].
	^self error: 'Not found class: ' , className printString! !
