'Oom010 (11/18/2001 8:36:05 am)'.!


OomSequence variableSubclass: #OomMatrix
	instanceVariableNames: 'rowSize columnSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Collections-Sequenceable'!
!OomMatrix commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMatrix methodsFor: 'accessing'!
at: indexInteger 
	^self basicAt: indexInteger! !

!OomMatrix methodsFor: 'accessing'!
at: indexInteger put: anObject 
	^self basicAt: indexInteger put: anObject! !

!OomMatrix methodsFor: 'accessing'!
atPoint: aPoint 
	| location |
	location := self computeLocation: aPoint.
	location > self size
		ifTrue: [^self subscriptOutOfBoundsError: aPoint]
		ifFalse: [^self at: location]! !

!OomMatrix methodsFor: 'accessing'!
atPoint: aPoint put: anObject 
	| location |
	location := self computeLocation: aPoint.
	location > self size ifTrue: [^self subscriptOutOfBoundsError: aPoint].
	self at: location put: anObject! !

!OomMatrix methodsFor: 'accessing'!
collection: collection 
	1 to: (self size min: collection size)
		do: [:i | self at: i put: (collection at: i)]! !

!OomMatrix methodsFor: 'accessing'!
matrixSize
	^self rowSize @ self columnSize! !

!OomMatrix methodsFor: 'accessing'!
row: rowNumber column: columnNumber 
	^self atPoint: rowNumber @ columnNumber! !

!OomMatrix methodsFor: 'accessing'!
row: rowNumber column: columnNumber put: anObject 
	^self atPoint: rowNumber @ columnNumber put: anObject! !

!OomMatrix methodsFor: 'accessing'!
size
	^self basicSize! !


!OomMatrix methodsFor: 'row accessing'!
atRow: anInteger 
	| row |
	row := OrderedCollection new: self columnSize.
	1 to: self columnSize do: [:j | row add: (self atPoint: anInteger @ j)].
	^row! !

!OomMatrix methodsFor: 'row accessing'!
rowSize
	^rowSize! !


!OomMatrix methodsFor: 'column accessing'!
atColumn: anInteger 
	| column |
	column := OrderedCollection new: self rowSize.
	1 to: self rowSize do: [:i | column add: (self atPoint: i @ anInteger)].
	^column! !

!OomMatrix methodsFor: 'column accessing'!
columnSize
	^columnSize! !


!OomMatrix methodsFor: 'adding'!
add: newObject 
	self shouldNotImplement! !


!OomMatrix methodsFor: 'removing'!
remove: oldObject ifAbsent: anExceptionBlock 
	self shouldNotImplement! !


!OomMatrix methodsFor: 'converting'!
asDouble
	| collection |
	collection := OrderedCollection new.
	self do: [:each | collection add: each asDouble].
	^self species
		new: self rowSize
		by: self columnSize
		collection: collection! !

!OomMatrix methodsFor: 'converting'!
asFloat
	| collection |
	collection := OrderedCollection new.
	self do: [:each | collection add: each asFloat].
	^self species
		new: self rowSize
		by: self columnSize
		collection: collection! !


!OomMatrix methodsFor: 'copying'!
copyFrom: startPoint to: endPoint 
	| i j m v sp ep |
	sp := 1 @ 1 max: startPoint.
	ep := startPoint max: (self matrixSize min: endPoint).
	m := self species new: ep x - sp x + 1 by: ep y - sp y + 1.
	i := 1.
	[i <= m rowSize]
		whileTrue: 
			[j := 1.
			[j <= m columnSize]
				whileTrue: 
					[v := self atPoint: sp - (1 @ 1) + (i @ j).
					m atPoint: i @ j put: v.
					j := j + 1].
			i := i + 1].
	^m! !


!OomMatrix methodsFor: 'enumerating'!
columnIndex: anInteger do: aBlock 
	self columnIndex: anInteger doI: [:v :i | aBlock value: v]! !

!OomMatrix methodsFor: 'enumerating'!
columnIndex: anInteger doI: aBlock 
	1 to: self rowSize do: [:i | aBlock value: (self atPoint: i @ anInteger)
			value: i]! !

!OomMatrix methodsFor: 'enumerating'!
do: aBlock 
	self doIJ: [:v :i :j | aBlock value: v]! !

!OomMatrix methodsFor: 'enumerating'!
doIJ: aBlock 
	| i j |
	i := 1.
	[i <= self rowSize]
		whileTrue: 
			[j := 1.
			[j <= self columnSize]
				whileTrue: 
					[aBlock
						value: (self atPoint: i @ j)
						value: i
						value: j.
					j := j + 1].
			i := i + 1]! !

!OomMatrix methodsFor: 'enumerating'!
reverseDo: aBlock 
	self reverseDoIJ: [:v :i :j | aBlock value: v]! !

!OomMatrix methodsFor: 'enumerating'!
reverseDoIJ: aBlock 
	| i j |
	i := self rowSize.
	[i > 0]
		whileTrue: 
			[j := self columnSize.
			[j > 0]
				whileTrue: 
					[aBlock
						value: (self atPoint: i @ j)
						value: i
						value: j.
					j := j - 1].
			i := i - 1]! !

!OomMatrix methodsFor: 'enumerating'!
rowIndex: anInteger do: aBlock 
	self rowIndex: anInteger doJ: [:v :j | aBlock value: v]! !

!OomMatrix methodsFor: 'enumerating'!
rowIndex: anInteger doJ: aBlock 
	1 to: self columnSize do: [:j | aBlock value: (self atPoint: anInteger @ j)
			value: j]! !


!OomMatrix methodsFor: 'arithmetic'!
compute: aSymbol with: aMatrix 
	| newMatrix newValue |
	(aMatrix isKindOf: Number)
		ifTrue: 
			[newMatrix := self copy.
			newMatrix
				doIJ: 
					[:v :i :j | 
					newValue := newMatrix atPoint: i @ j.
					newValue := newValue perform: aSymbol with: aMatrix.
					newMatrix atPoint: i @ j put: newValue]]
		ifFalse: 
			[newMatrix := self copy.
			newMatrix
				doIJ: 
					[:v :i :j | 
					newValue := newMatrix atPoint: i @ j.
					(i <= aMatrix rowSize and: [j <= aMatrix columnSize])
						ifTrue: [newValue := newValue perform: aSymbol with: (aMatrix atPoint: i @ j)].
					newMatrix atPoint: i @ j put: newValue]].
	^newMatrix! !


!OomMatrix methodsFor: 'matrix functions'!
product: aMatrix 
	| newMatrix answer |
	self columnSize = aMatrix rowSize ifFalse: [^self error: 'Can not compute (My column size ~= argument row size)'].
	newMatrix := self species new: self rowSize by: aMatrix columnSize.
	1 to: self rowSize do: [:i | 1 to: aMatrix columnSize do: 
			[:j | 
			answer := 0.
			self rowIndex: i doJ: [:value :k | answer := answer + (value * (aMatrix atPoint: k @ j))].
			newMatrix atPoint: i @ j put: answer]].
	^newMatrix! !


!OomMatrix methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: '('.
	self
		doIJ: 
			[:v :i :j | 
			i @ j printOn: aStream.
			aStream nextPutAll: ': '.
			v printOn: aStream.
			aStream cr].
	self isEmpty ifFalse: [aStream skip: -1].
	aStream nextPutAll: ')'! !


!OomMatrix methodsFor: 'private'!
computeLocation: aPoint 
	| row column |
	row := (aPoint x max: 1)
				min: self rowSize.
	column := (aPoint y max: 1)
				min: self columnSize.
	^row - 1 * self columnSize + column! !

!OomMatrix methodsFor: 'private'!
rowIndex: anInteger convert: aBlock 
	self rowIndex: anInteger convertJ: [:v :j | aBlock value: v value: j]! !

!OomMatrix methodsFor: 'private'!
rowIndex: anInteger convertJ: aBlock 
	self rowIndex: anInteger doJ: [:v :j | self atPoint: anInteger @ j put: (aBlock value: v value: j)]! !

!OomMatrix methodsFor: 'private'!
rowSize: sizeOfRow columnSize: sizeOfColumn 
	rowSize := sizeOfRow max: 0.
	columnSize := sizeOfColumn max: 0! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMatrix class
	instanceVariableNames: ''!

!OomMatrix class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMatrix class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMatrix class methodsFor: 'copyright'!
version
	^'010'! !


!OomMatrix class methodsFor: 'instance creation'!
new
	^self new: 0! !

!OomMatrix class methodsFor: 'instance creation'!
new: squareSize 
	| square |
	square := squareSize max: 0.
	^(super new: square * square)
		rowSize: square columnSize: square! !

!OomMatrix class methodsFor: 'instance creation'!
new: rowSize by: columnSize 
	| row column |
	row := rowSize max: 0.
	column := columnSize max: 0.
	^(super new: row * column)
		rowSize: row columnSize: column! !

!OomMatrix class methodsFor: 'instance creation'!
new: rowSize by: columnSize collection: collection 
	^(self new: rowSize by: columnSize)
		collection: collection! !


!OomMatrix class methodsFor: 'examples'!
example1
	"OomMatrix example1."

	| matrix value |
	matrix := OomMatrix
				new: 3
				by: 4
				collection: #(1 2 3 4 5 6 7 8 9 10 11 12).
	1 to: matrix rowSize
		do: 
			[:row | 
			Transcript cr.
			1 to: matrix columnSize
				do: 
					[:column | 
					value := matrix atPoint: row @ column.
					Transcript show: value printString.
					Transcript space]].
	^matrix! !

!OomMatrix class methodsFor: 'examples'!
example2
	"OomMatrix example2."

	| matrix1 matrix2 matrix value |
	matrix1 := OomMatrix
				new: 3
				by: 4
				collection: #(1 2 3 4 5 6 7 8 9 10 11 12).
	matrix2 := OomMatrix
				new: 3
				by: 4
				collection: #(1 2 3 4 5 6 7 8 9 10 11 12).
	matrix := matrix1 * matrix2.
	1 to: matrix rowSize
		do: 
			[:row | 
			Transcript cr.
			1 to: matrix columnSize
				do: 
					[:column | 
					value := matrix atPoint: row @ column.
					Transcript show: value printString.
					Transcript space]].
	^matrix! !
