'Oom010 (11/18/2001 8:36:05 am)'.!


Object subclass: #OomProgress
	instanceVariableNames: 'progressValue progressMessage stopCondition progressBarFrame messageFrame savedArea hasStopButton stopButtonFrame watchingProcess accessProtect '
	classVariableNames: 'ProgressScale QuartersCursor '
	poolDictionaries: ''
	category: 'Oom-Interface-Progress'!
!OomProgress commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomProgress methodsFor: 'initialize-release' stamp: 'nishis 1/4/1999 08:53'!
initialize
	accessProtect := false.
	self value: 0.
	self message: Character space asString! !


!OomProgress methodsFor: 'accessing' stamp: 'nishis 12/16/1998 03:32'!
message
	^progressMessage! !

!OomProgress methodsFor: 'accessing' stamp: 'nishis 12/18/1998 15:12'!
message: aString 
	| oldString |
	oldString := progressMessage.
	progressMessage := aString.
	oldString ~= progressMessage 
		ifTrue: 
			[self displayMessage]! !

!OomProgress methodsFor: 'accessing'!
value
	^progressValue! !

!OomProgress methodsFor: 'accessing' stamp: 'nishis 12/18/1998 15:12'!
value: normalizedNumber 
	| oldValue |
	(0 <= normalizedNumber and: [normalizedNumber <= 1])
		ifTrue: 
			[oldValue := progressValue.
			progressValue := normalizedNumber.
			oldValue ~= progressValue 
				ifTrue: 
					[self displayValue]]! !


!OomProgress methodsFor: 'testing' stamp: 'nishis 12/16/1998 17:53'!
hasStopButton
	^hasStopButton! !

!OomProgress methodsFor: 'testing' stamp: 'nishis 12/18/1998 21:07'!
isDragging
	| box |
	box := self messageFrame origin extent: savedArea extent.
	^(box containsPoint: Sensor cursorPoint) and: [Sensor anyButtonPressed].
! !

!OomProgress methodsFor: 'testing' stamp: 'nishis 12/16/1998 17:53'!
isOpen
	^self progressBarFrame notNil and: [self messageFrame notNil]! !

!OomProgress methodsFor: 'testing' stamp: 'nishis 12/16/1998 18:06'!
stopButtonPressed
	| box bool point |
	stopCondition = true ifTrue: [^true].
	box := self stopButtonFrame.
	box isNil ifTrue: [^false].
	self isOpen ifFalse: [^false].
	bool := false.
	point := Sensor cursorPoint.
	[(box containsPoint: point) and: [Sensor anyButtonPressed]]
		whileTrue: 
			[bool ifFalse: [self displayStopButton: true].
			bool := true.
			point := Sensor cursorPoint].
	point := Sensor cursorPoint.
	bool ifTrue: [self displayStopButton: false].
	(bool and: [box containsPoint: point])
		ifTrue: 
			[stopCondition := true.
			^true].
	^false! !


!OomProgress methodsFor: 'moving' stamp: 'nishis 1/4/1999 08:57'!
move	
	| box point offset bool delta |
	savedArea isNil ifTrue: [^false].
	self stopButtonPressed ifTrue: [^false].
	box := self messageFrame origin extent: (self progressBarFrame merge: self messageFrame) extent.
	box isNil ifTrue: [^false].
	self isOpen ifFalse: [^false].
	accessProtect ifTrue: [^false].
	point := Sensor cursorPoint.
	Sensor anyButtonPressed ifFalse: [^false].
	bool := (box containsPoint: point) and: [Sensor anyButtonPressed].
	[(box containsPoint: point) and: [Sensor anyButtonPressed]]
		whileTrue: 
			[self quartersCursor 
				showWhile: 
					[offset := box origin - point.
					box := self newRectFrom: box trackingBlock: [:ignored | Sensor cursorPoint + offset extent: savedArea extent].
					point := Sensor cursorPoint]].
	bool ifFalse: [^false].
	savedArea displayOn: Display at: self messageFrame origin.
	delta := box origin - self messageFrame origin.
	self progressBarFrame: (self progressBarFrame translateBy: delta).
	self messageFrame: (self messageFrame translateBy: delta).
	savedArea := Form fromDisplay: box.
	self displayFrameOutline.
	self displayValue.
	self displayMessage.
	^true! !


!OomProgress methodsFor: 'enumerating' stamp: 'nishis 12/18/1998 20:41'!
do: aBlock 
	"
	OomProgress new 
		do: [:progress | 
			(0 to: 1 by: 0.01) do: [:n | 
				progress message: n printString. 
				progress value: n]].
	"

	| result |
	self openWithStopButton: false.
	[self prologue.
	watchingProcess resume.
	Cursor execute 
		showWhile: 
			[aBlock numArgs = 0
				ifTrue: [result := aBlock value]
				ifFalse: [result := aBlock value: self]].
	self epilogue.
	self close] 
		ifError: 
			[:msg :rec | 
			self debug: [Transcript cr; show: msg printString , '>' , rec printString].
			self epilogue.
			self close].
	^result! !

!OomProgress methodsFor: 'enumerating' stamp: 'nishis 12/18/1998 20:41'!
doWithStopButton: aBlock 
	"
	OomProgress new 
		doWithStopButton: [:progress | 
			(0 to: 1 by: 0.01) do: [:n | 
				progress message: n printString. 
				progress value: n.
				progress stopButtonPressed ifTrue: [progress close]]].
	"

	| result |
	self openWithStopButton: true.
	[self prologue.
	watchingProcess resume.
	Cursor execute 
		showWhile: 
			[aBlock numArgs = 0
				ifTrue: [result := aBlock value]
				ifFalse: [result := aBlock value: self]].
	self epilogue.
	self close] 
		ifError: 
			[:msg :rec | 
			self debug: [Transcript cr; show: msg printString , '>' , rec printString].
			self epilogue.
			self close].
	^result! !


!OomProgress methodsFor: 'interface opening' stamp: 'nishis 12/18/1998 20:30'!
createFrames
	| delta captionText textFrame barFrame outerFrame barFrameWidth barFrameHeight |
	barFrameWidth := self hasStopButton 
						ifTrue: [226 + self stopButtonFrameWidth] 
						ifFalse: [226].
	barFrameHeight := 40.
	barFrame := Sensor cursorPoint - ((barFrameWidth @ barFrameHeight) // 2) 
						corner: Sensor cursorPoint + ((barFrameWidth @ barFrameHeight) // 2).
	captionText := self message isNil ifTrue: ['dummy'] ifFalse: [self message].
	captionText := DisplayText text: captionText asText allBold.
	captionText
		foregroundColor: Color black
		backgroundColor: Color white.
	textFrame := (0 @ 0 extent: barFrame extent) 
					withHeight: (captionText boundingBox insetBy: (captionText boundingBox height // -2)) height.
	textFrame := textFrame align: textFrame bottomCenter
					with: barFrame topCenter + (0@2).
	outerFrame := barFrame merge: textFrame.
	delta := outerFrame amountToTranslateWithin: Display boundingBox.
	barFrame := barFrame translateBy: delta.
	textFrame := textFrame translateBy: delta.
	outerFrame := outerFrame translateBy: delta.
	savedArea := Form fromDisplay: outerFrame.
	self progressBarFrame: barFrame.
	self messageFrame: textFrame.

	^outerFrame! !

!OomProgress methodsFor: 'interface opening' stamp: 'nishis 12/18/1998 18:31'!
openWithStopButton: aBoolean 
	stopCondition := false.
	hasStopButton := aBoolean.
	self createFrames.
	self displayFrameOutline.
	self displayMessage! !


!OomProgress methodsFor: 'interface closing' stamp: 'nishis 12/21/1998 05:47'!
close
	self isOpen ifFalse: [^nil].
	stopCondition := true.
	savedArea displayOn: Display at: self messageFrame origin.
	self progressBarFrame: nil.
	self messageFrame: nil! !


!OomProgress methodsFor: 'schedulering' stamp: 'nishis 12/18/1998 18:30'!
epilogue
	(watchingProcess isMemberOf: Process)
		ifTrue: [watchingProcess terminate].
	watchingProcess := nil! !

!OomProgress methodsFor: 'schedulering' stamp: 'nishis 1/4/1999 09:15'!
prologue
	watchingProcess := 
		[[self isOpen] 
			whileTrue: 
				[(Delay forMilliseconds: 100) wait.
				self move]] newProcess.
	watchingProcess priority: Processor userInterruptPriority! !


!OomProgress methodsFor: 'debugging' stamp: 'nishis 1/4/1999 09:00'!
debug: aBlock
	"aBlock value"! !


!OomProgress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:05'!
fakeStopButton: aBoolean
	| aFrame stopButtonFrameWidth spaceLeft |
	aBoolean 
		ifTrue: 
			[stopButtonFrameWidth := self stopButtonFrameWidth.
			self messageFrame: (self messageFrame withWidth: (savedArea width - stopButtonFrameWidth)).
			self progressBarFrame: (self progressBarFrame withWidth: (savedArea width - stopButtonFrameWidth)).
			aFrame := self messageFrame topRight extent: stopButtonFrameWidth @ (savedArea height // 2).
			spaceLeft := self messageFrame topRight extent: stopButtonFrameWidth @ (savedArea height).
			aFrame := aFrame align: aFrame center with: spaceLeft center.
			self stopButtonFrame: aFrame.
			self displayStopButton: false]
		ifFalse: 
			[self stopButtonFrame: nil]! !

!OomProgress methodsFor: 'private' stamp: 'nishis 5/16/98 15:56'!
messageFrame
	^messageFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 5/16/98 15:57'!
messageFrame: aFrame
	messageFrame := aFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 5/16/98 15:56'!
progressBarFrame
	^progressBarFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 5/16/98 15:57'!
progressBarFrame: aFrame
	progressBarFrame := aFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/19/1998 01:24'!
progressScale
	^self class progressScale! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/21/1998 06:01'!
quartersCursor
	^self class quartersCursor! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/16/1998 17:55'!
stopButtonFrame
	^stopButtonFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/14/1998 07:11'!
stopButtonFrame: aFrame
	stopButtonFrame := aFrame! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:15'!
stopButtonFrameWidth
	^self stopButtonLabel width + 32! !

!OomProgress methodsFor: 'private' stamp: 'nishis 12/18/1998 21:15'!
stopButtonLabel
	^DisplayText text: 'stop' asText allBold! !


!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:36'!
displayFrameOutline
	| aRectengle |
	aRectengle := self messageFrame origin extent: savedArea extent.
	Display fillBlack: aRectengle; fillWhite: (aRectengle insetBy: 2).
	self fakeStopButton: self hasStopButton! !

!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 09:01'!
displayMessage
	| displayText displayRectangle scaleRectangle clippingRectangle |
	self messageFrame isNil ifTrue: [^nil].
	accessProtect := true.
	displayText := DisplayText text: self message asText allBold.
	"do not send message 'boundingBox' directly to displayText."
	displayRectangle := displayText copy boundingBox.
	scaleRectangle := 0 @ 0 extent: 200 + 1 @ displayRectangle height.
	clippingRectangle := self messageFrame insetBy: 4.
	scaleRectangle := scaleRectangle align: scaleRectangle center with: clippingRectangle center.
	displayRectangle := displayRectangle align: displayRectangle bottomLeft with: scaleRectangle bottomLeft.
	Display fillWhite: clippingRectangle.
	displayText foregroundColor: Color black backgroundColor: Color white;
		displayOn: Display at: displayRectangle origin clippingBox: clippingRectangle.
	accessProtect := false! !

!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 08:52'!
displayProgressBar
	| gaugeRectangle pointArray displayRectangle clippingRectangle |
	self progressBarFrame isNil ifTrue: [^nil].
	gaugeRectangle := 0 @ 0 extent: 6 @ 12.
	displayRectangle := 0 @ 0 extent: 200 + 1 @ 10.
	clippingRectangle := (0 @ (self progressBarFrame height // 2 * 0) corner: self progressBarFrame width @ (self progressBarFrame height // 2 * 1)) insetBy: 2.
	clippingRectangle := clippingRectangle align: clippingRectangle bottomCenter with: self progressBarFrame center.
	displayRectangle := displayRectangle align: displayRectangle bottomCenter with: clippingRectangle bottomCenter.
	gaugeRectangle := gaugeRectangle align: gaugeRectangle bottomCenter with: displayRectangle bottomLeft.
	gaugeRectangle := (gaugeRectangle translateBy: self value * 200 @ -1) rounded.
	Display fillWhite: clippingRectangle.
	pointArray := Array new: 5.
	pointArray at: 1 put: gaugeRectangle topCenter.
	pointArray at: 2 put: gaugeRectangle rightCenter.
	pointArray at: 3 put: gaugeRectangle bottomCenter.
	pointArray at: 4 put: gaugeRectangle leftCenter.
	pointArray at: 5 put: gaugeRectangle topCenter.
	self displayPolygonOn: Display points: pointArray at: 0 @ 0! !

!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:31'!
displayScale
	| displayRectangle clippingRectangle |
	displayRectangle := 0 @ 0 extent: self progressScale extent.
	clippingRectangle := (0 @ (self progressBarFrame height // 2 * 1) corner: self progressBarFrame width @ (self progressBarFrame height // 2 * 2)) insetBy: 2.
	clippingRectangle := clippingRectangle align: clippingRectangle topCenter with: self progressBarFrame center.
	displayRectangle := displayRectangle align: displayRectangle topCenter with: clippingRectangle topCenter.
	self progressScale displayOn: Display at: displayRectangle origin! !

!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 12/19/1998 01:45'!
displayStopButton: aBoolean
	| aFrame stopLabel dropFrame backgroundColor stopLabelRectangle |
	aFrame := self stopButtonFrame insetBy: 4.
	dropFrame := aFrame insetBy: 3.
	backgroundColor := Color lightGray.
	Display fillBlack: aFrame; fill: (aFrame insetBy: 2) rule: Form over fillColor: backgroundColor.
	Display fill: dropFrame rule: Form over fillColor: backgroundColor.
	aBoolean 
		ifTrue: 
			[self displayLineOn: Display from: dropFrame bottomLeft to: dropFrame bottomRight color: Color white.
			self displayLineOn: Display from: dropFrame bottomRight to: dropFrame topRight color: Color white.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame bottomLeft color: Color black.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame topRight color: Color black]
		ifFalse: 
			[self displayLineOn: Display from: dropFrame bottomLeft to: dropFrame bottomRight color: Color black.
			self displayLineOn: Display from: dropFrame bottomRight to: dropFrame topRight color: Color black.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame bottomLeft color: Color white.
			self displayLineOn: Display from: dropFrame topLeft to: dropFrame topRight color: Color white].
	stopLabel := self stopButtonLabel.
	stopLabelRectangle := 0 @ 0 extent: stopLabel computeBoundingBox extent.
	stopLabelRectangle := stopLabelRectangle align: stopLabelRectangle center with: aFrame center.
	stopLabel
		foregroundColor: Color black backgroundColor: backgroundColor;
		displayOn: Display at: stopLabelRectangle origin! !

!OomProgress methodsFor: 'private diplaying' stamp: 'nishis 1/4/1999 08:53'!
displayValue 
	self progressBarFrame isNil ifTrue: [^nil].
	accessProtect := true.
	self displayScale.
	self displayProgressBar.
	accessProtect := false
! !


!OomProgress methodsFor: 'private transforming' stamp: 'nishis 1/4/1999 09:20'!
newRectFrom: originalRect trackingBlock: newRectBlock 
	"Track the outline of a new rectangle until mouse button changes.
	newFrameBlock produces each new rectangle from the previous"
	"copied and modified from below"
	"Browser fullOnClass: Rectangle selector: #newRectFrom:."

	| rect newRect buttonStart buttonNow mutex delta |
	mutex := Semaphore forMutualExclusion.
	mutex critical: 
		[buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originalRect.
		Display border: rect width: 2 rule: Form reverse fillColor: Color gray.
		[buttonNow == buttonStart] whileTrue: 
			["Give other Processes at the current priority NO chance to run."
			"Processor yield."
			buttonNow := Sensor anyButtonPressed.
			newRect := newRectBlock value: rect.
			delta := newRect amountToTranslateWithin: Display boundingBox.
			newRect = rect ifFalse:
				[newRect := newRect translateBy: delta.
				Display border: rect width: 2 rule: Form reverse fillColor: Color gray.
				Display border: newRect width: 2 rule: Form reverse fillColor: Color gray.
				rect := newRect]].
		Display border: rect width: 2 rule: Form reverse fillColor: Color gray].
	^ rect! !


!OomProgress methodsFor: 'private displaying-generic' stamp: 'nishis 12/19/1998 01:30'!
displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color
	self class displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color! !

!OomProgress methodsFor: 'private displaying-generic' stamp: 'nishis 12/18/1998 00:23'!
displayPolygonOn: aDisplayMedium points: points at: offsetPoint 
	"not implemented yet."

	| aLinearFit aForm |
	aLinearFit := LinearFit new.
	aForm := Form extent: 1 @ 1.
	aForm fillColor: Color black.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: aDisplayMedium at: offsetPoint clippingBox: aDisplayMedium boundingBox "rule: Form and fillColor: nil"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomProgress class
	instanceVariableNames: ''!

!OomProgress class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomProgress class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomProgress class methodsFor: 'copyright'!
version
	^'010'! !


!OomProgress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
flushCursors
	"OomProgress flushCursors."

	QuartersCursor := nil! !

!OomProgress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:08'!
initialize
	"OomProgress initialize."

	self install! !

!OomProgress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
install
	"OomProgress install."

	self progressScale.
	self quartersCursor! !

!OomProgress class methodsFor: 'class initialization' stamp: 'nishis 12/21/1998 06:07'!
uninstall
	"OomProgress uninstall."

	self flushCursors.
	ProgressScale := nil ! !


!OomProgress class methodsFor: 'instance creation' stamp: 'nishis 12/16/1998 02:32'!
new
	^super new initialize! !


!OomProgress class methodsFor: 'accessing' stamp: 'nishis 12/19/1998 01:26'!
progressScale
	"OomProgress progressScale."

	| displayRectangle x p color |
	ProgressScale notNil ifTrue: [^ProgressScale]. 
	ProgressScale := Form extent: 200 + 1 @ 10.
	displayRectangle := 0 @ 0 extent: 200 + 1 @ 10.
	color := Color black.
	x := displayRectangle left.
	0 to: 100 
		do: 
			[:n | 
			n \\ 5 = 0
				ifTrue: [n \\ 10 = 0
						ifTrue: [n \\ 50 = 0
								ifTrue: 
									[p := x @ displayRectangle top.
									self displayLineOn: ProgressScale from: p to: p + (0 @ 10) color: color]
								ifFalse: 
									[p := x @ (displayRectangle top + 2).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 6) color: color]]
						ifFalse: [n \\ 25 = 0
								ifTrue: [p := x @ (displayRectangle top + 4).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 6) color: color]
								ifFalse: 
									[p := x @ (displayRectangle top + 4).
									self displayLineOn: ProgressScale from: p to: p + (0 @ 4) color: color]]]
				ifFalse: 
					[p := x @ (displayRectangle top + 6).
					self displayLineOn: ProgressScale from: p to: p + (0 @ 2) color: color].
			x := x + 2].
	^ProgressScale! !

!OomProgress class methodsFor: 'accessing' stamp: 'nishis 12/21/1998 06:00'!
quartersCursor
	"OomProgress quartersCursor."
	"
	OomProgress quartersCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"OomProgress flushCursors."

	QuartersCursor notNil ifTrue: [^QuartersCursor].
	QuartersCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0010000000000100
2r0111110001111110
2r0010000000000100
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000001110000000
2r0010001110000100
2r0111111011111110
2r1111110001111111
2r0111111011111110
2r0010001110000100
2r0000001110000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
)
				offset: 7 @ 7.
	^QuartersCursor! !


!OomProgress class methodsFor: 'private' stamp: 'nishis 12/19/1998 01:13'!
displayLineOn: aDisplayMedium from: fromPoint to: toPoint color: color
	| aForm aLine |
	aForm := Form extent: 1 @ 1 depth: Display depth.
	aForm fillColor: color.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: aDisplayMedium! !

!OomProgress class methodsFor: 'private' stamp: 'nishis 12/17/1998 23:34'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!OomProgress class methodsFor: 'private' stamp: 'nishis 12/17/1998 23:34'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1! !


!OomProgress class methodsFor: 'examples' stamp: 'nishis 7/5/1998 07:08'!
example1
	"OomProgress example1."

	| collection size count value |
	collection := 1 to: 100.
	size := collection size.
	OomProgress new
		do: 
			[:progress | 
			count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					(Delay forMilliseconds: 100) wait.
					count := count + 1]]! !

!OomProgress class methodsFor: 'examples' stamp: 'nishis 12/17/1998 17:42'!
example2
	"OomProgress example2."

	| collection size count value |
	collection := 1 to: 100.
	size := collection size.
	OomProgress new
		doWithStopButton: 
			[:progress | 
			count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]]! !

!OomProgress class methodsFor: 'examples' stamp: 'nishis 7/4/1998 18:20'!
example3
	"OomProgress example3."

	| collection size count value progress block |
	collection := 1 to: 100.
	size := collection size.
	progress := OomProgress new.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					value := count / size.
					progress message: value asFloat printString.
					progress value: value.
					(Delay forMilliseconds: 100) wait.
					count := count + 1]].
	progress openWithStopButton: false.
	block value.
	progress close! !

!OomProgress class methodsFor: 'examples' stamp: 'nishis 12/18/1998 14:45'!
example4
	"OomProgress example4."

	| collection size progress block count value |
	collection := 1 to: 100.
	size := collection size.
	progress := OomProgress new.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					progress hasStopButton
						ifTrue: [value := 1 - (count / size)]
						ifFalse: [value := count / size].
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]].
	progress do: block.
	progress doWithStopButton: block! !

!OomProgress class methodsFor: 'examples' stamp: 'nishis 1/4/1999 09:35'!
example5
	"OomProgress example5."

	| collection size progress count value cursorAnimator block |
	collection := 1 to: 100.
	size := collection size.
	progress := OomProgress new.
	progress message: 'computing...'.
	cursorAnimator := OomCursorAnimator handCursors.
	cursorAnimator tick: 300.
	block := 
			[count := 1.
			collection
				do: 
					[:each | 
					progress hasStopButton
						ifTrue: [value := 1 - (count / size)]
						ifFalse: [value := count / size].
					progress message: value asFloat printString.
					progress value: value.
					progress stopButtonPressed
						ifTrue: [progress close]
						ifFalse: [(Delay forMilliseconds: 100) wait].
					count := count + 1]].
	cursorAnimator showWhile: [progress do: block].
	cursorAnimator showWhile: [progress doWithStopButton: block]! !


OomProgress initialize!
