'Oom010 (11/18/2001 8:36:06 am)'.!


View subclass: #OomPopularityView
	instanceVariableNames: 'xScale yScale numericalInfo xLabel yLabel pointCollection visual '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Popularity'!
!OomPopularityView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomPopularityView methodsFor: 'accessing' stamp: 'nishis 11/14/1998 15:31'!
visual
	^visual! !

!OomPopularityView methodsFor: 'accessing' stamp: 'nishis 11/14/1998 15:32'!
visual: anObject
	visual := anObject! !


!OomPopularityView methodsFor: 'area accessing' stamp: 'nishis 7/18/1998 15:30'!
marginRectangle
	^Rectangle
		left: 8 + self yLabel width
		right: 4
		top: 4
		bottom: 8 + self xLabel height! !

!OomPopularityView methodsFor: 'area accessing' stamp: 'nishis 7/18/1998 16:22'!
pointCollection
	| size ranking xmin xmax ymin ymax area point width height location |
	pointCollection isNil ifTrue: [(size := (ranking := self model ranking) size) < 1
			ifTrue: [pointCollection := OrderedCollection new]
			ifFalse: [Cursor wait
					showWhile: 
						[pointCollection := OrderedCollection new: size.
						self model log
							ifTrue: 
								[xmin := 0.
								xmax := 0.
								ranking do: [:assoc | xmax := xmax max: assoc key asFloat log].
								ymin := 0.
								ymax := 0.
								ranking do: [:assoc | ymax := ymax max: (assoc value = 0
													ifTrue: [assoc value]
													ifFalse: [assoc value asFloat log])].
								area := self rankingArea.
								point := area bottomLeft.
								ranking
									do: 
										[:assoc | 
										width := area width / (xmax - xmin) * assoc key asFloat log.
										height := area height / (ymax - ymin) * (assoc value = 0
														ifTrue: [assoc value]
														ifFalse: [assoc value asFloat log]).
										location := (point x + width @ (point y - height)) rounded.
										pointCollection add: (Array with: location with: assoc value)]]
							ifFalse: 
								[xmin := 0.
								xmax := 0.
								ranking do: [:assoc | xmax := xmax max: assoc key].
								ymin := 0.
								ymax := 0.
								ranking do: [:assoc | ymax := ymax max: assoc value].
								area := self rankingArea.
								point := area bottomLeft.
								ranking
									do: 
										[:assoc | 
										width := area width / (xmax - xmin) * assoc key.
										height := area height / (ymax - ymin) * assoc value.
										location := (point x + width @ (point y - height)) rounded.
										pointCollection add: (Array with: location with: assoc value)]]]]].
	^pointCollection! !

!OomPopularityView methodsFor: 'area accessing' stamp: 'nishis 7/18/1998 17:49'!
rankingArea
	| margin left top right bottom area |
	margin := self marginRectangle.
	left := 0.
	self yScale do: [:each | left := left max: each value width].
	left := margin left + left + 4.
	top := margin top + self numericalInfo boundingBox height + 4.
	right := margin right.
	bottom := 0.
	self xScale do: [:each | bottom := bottom max: each value height].
	bottom := margin bottom + bottom + 4.
	area := (0 @ 0 extent: self insetDisplayBox extent) "self boundingBox" insetBy: (left @ top corner: right @ bottom).
	^area! !


!OomPopularityView methodsFor: 'bounds accessing' stamp: 'nishis 11/14/1998 18:26'!
computeInsetDisplayBox
	| viewExtent |

	"for resizing"
	viewExtent := ((self superView insetDisplayBox
						intersect: (self displayTransform: self getWindow)) truncated
						insetBy: borderWidth) extent.
	(self visual notNil and: [viewExtent ~= self visual extent]) 
		ifTrue: [pointCollection := nil].
	^super computeInsetDisplayBox! !


!OomPopularityView methodsFor: 'controller accessing' stamp: 'nishis 7/18/1998 14:26'!
defaultControllerClass
	^OomPopularityController! !


!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:09'!
displayNumericalInfoOn: graphicsContext 
	| info |
	info := self numericalInfo.
	info displayOn: graphicsContext at: self rankingArea right - info width @ self marginRectangle top! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 7/18/1998 15:07'!
displayOn: graphicsContext 
	| visibleAreas |
	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:10'!
displayRankingOn: graphicsContext 
	| points box clip |
	Cursor execute
		showWhile: 
			[points := (self pointCollection collect: [:a | a first]) asArray.
			self displayPolylineOn: graphicsContext points: points lineWidth: 1 color: self model color.
			box := 0 @ 0 extent: 1 @ 1.
			clip := (0 @ 0 extent: self insetDisplayBox extent).
			points
				do: 
					[:p | 
					box := box align: box center with: p.
					(clip intersects: box)
						ifTrue: [self displayRectangleOn: graphicsContext rectangle: box lineWidth: 1 color: self model color]]]! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 18:25'!
displayView
	pointCollection isNil 
		ifTrue: 
			[visual := Form extent: self insetDisplayBox extent depth: Display depth.
			visual fillWithColor: Color white.
			self displayYScaleOn: visual.
			self displayXScaleOn: visual.
			self displayRankingOn: visual.
			self displayNumericalInfoOn: visual.
			self displayYLabelOn: visual.
			self displayXLabelOn: visual].
	self displayOn: visual! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 7/18/1998 19:11'!
displayXLabelOn: graphicsContext 
	| label box |
	label := self xLabel.
	box := label boundingBox.
	box := box align: box bottomCenter with: self rankingArea center x @ (self bounds bottom - 4).
	label displayOn: graphicsContext at: box origin! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:10'!
displayXScaleOn: graphicsContext 
	| area point box |
	area := self rankingArea.
	self displayLineOn: graphicsContext from: area bottomLeft to: area bottomRight lineWidth: 1 color: Color black.
	self xScale
		do: 
			[:assoc | 
			point := area bottomLeft + (area width * assoc key @ 0) rounded.
			self displayLineOn: graphicsContext from: point + (0 @ 2) to: point lineWidth: 1 color: Color black.
			box := assoc value boundingBox.
			box := box align: box topCenter with: point + (0 @ 4).
			assoc value displayOn: graphicsContext at: box origin]! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 7/18/1998 17:31'!
displayYLabelOn: graphicsContext 
	| label box |
	label := self yLabel.
	box := label boundingBox.
	box := box align: box leftCenter with: 4 @ (self rankingArea center y).
	label displayOn: graphicsContext at: box origin! !

!OomPopularityView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:10'!
displayYScaleOn: graphicsContext 
	| area point box |
	area := self rankingArea.
	self displayLineOn: graphicsContext from: area topLeft to: area bottomLeft lineWidth: 1 color: Color black.
	self yScale
		do: 
			[:assoc | 
			point := area bottomLeft - (0 @ (area height * assoc key)) rounded.
			self displayLineOn: graphicsContext from: point - (2 @ 0) to: point lineWidth: 1 color: Color black.
			box := assoc value boundingBox.
			box := box align: box rightCenter with: point - (4 @ 0).
			assoc value displayOn: graphicsContext at: box origin]! !


!OomPopularityView methodsFor: 'updating' stamp: 'nishis 11/14/1998 18:26'!
update: aspectSymbol 
	(aspectSymbol = #ranking or: [aspectSymbol = #sample])
		ifTrue: 
			[xScale := nil.
			yScale := nil.
			numericalInfo := nil.
			pointCollection := nil].
	(aspectSymbol = #description or: [aspectSymbol = #sample])
		ifTrue: 
			[xLabel := nil.
			yLabel := nil].
	self display! !


!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 19:11'!
bounds
	^0 @ 0 extent: self insetDisplayBox extent! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 15:11'!
numericalInfo
	| stream |
	numericalInfo isNil ifTrue: [Cursor wait
			showWhile: 
				[stream := WriteStream on: (String new: 64).
				stream nextPutAll: 'total: ' , self model total printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'count: ' , self model count printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'min: ' , self model minimum printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'max: ' , self model maximum printString.
				stream cr.
				stream nextPutAll: 'average: ' , (self model average asFloat truncateTo: 0.01) printString.
				stream nextPutAll: ', '.
				stream nextPutAll: 'deviation: ' , (self model deviation asFloat truncateTo: 0.01) printString.
				numericalInfo := Paragraph withText: stream contents asText style: self textStyle.
				numericalInfo rightFlush]].
	^numericalInfo! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 15:11'!
textStyle
	^TextStyle default copy! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 19:00'!
xLabel
	| string text pixmap image |
	xLabel isNil ifTrue: [Cursor wait
			showWhile: 
				[(string := self model horizontal) isNil
					ifTrue: [text := Paragraph withText: Text new style: self textStyle]
					ifFalse: [text := Paragraph withText: string asText style: self textStyle].
				pixmap := Form extent: text boundingBox extent depth: Display depth.
				text displayOn: pixmap.
				image := pixmap.
				xLabel := image]].
	^xLabel! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 15:15'!
xScale
	self model log
		ifTrue: [^self xScaleLog]
		ifFalse: [^self xScaleNum]! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 18:53'!
xScaleLog
	| ranking min max inc collection range pixmap image ratio interval value rotateImage |
	xScale isNil ifTrue: [Cursor wait
			showWhile: 
				[ranking := self model ranking.
				min := 0.
				max := 0.
				ranking do: [:assoc | max := max max: assoc key asFloat log].
				collection := OrderedCollection new.
				max - min > 0
					ifTrue: 
						[inc := 1.
						interval := min to: max by: inc.
						[interval size > 10]
							whileTrue: 
								[inc := inc * 2.
								interval := min to: max by: inc].
						interval
							do: 
								[:each | 
								ratio := each / (max - min).
								range := Paragraph withText: (10 raisedTo: each) printString asText style: self textStyle.
								pixmap := Form extent: range boundingBox extent.
								
								range displayOn: pixmap.
								image := pixmap.
								image boundingBox area > 0 
									ifTrue: 
										[rotateImage := Form extent: image height @ image width depth: Display depth.
										(image rotateBy: #left centerAt: 0@0) displayOn: rotateImage.
										image := rotateImage].
								collection add: ratio -> image.
								1 to: 3
									do: 
										[:n | 
										value := ((10 raisedTo: each + 1)
													* (n / 4)) asFloat log.
										(min <= value and: [value <= max])
											ifTrue: 
												[ratio := value / (max - min).
												range := Paragraph withText: ' ' asText style: self textStyle.
												pixmap := Form extent: range boundingBox extent.
												
												range displayOn: pixmap.
												image := pixmap.
												collection add: ratio -> image]]]].
				xScale := collection]].
	^xScale! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 18:53'!
xScaleNum
	| ranking min max inc collection range pixmap image ratio interval rotateImage |
	xScale isNil ifTrue: [Cursor wait
			showWhile: 
				[ranking := self model ranking.
				min := 0.
				max := 0.
				ranking do: [:assoc | max := max max: assoc key].
				collection := OrderedCollection new.
				max - min > 0
					ifTrue: 
						[inc := (10 raisedTo: (max - min)) printString size / 100 max: 1.
						interval := min to: max by: inc.
						[interval size > 10]
							whileTrue: 
								[inc := inc * 2.
								interval := min to: max by: inc].
						interval
							do: 
								[:each | 
								ratio := each / (max - min).
								range := Paragraph withText: each asInteger printString asText style: self textStyle.
								pixmap := Form extent: range boundingBox extent.
								
								range displayOn: pixmap.
								image := pixmap.
								image boundingBox area > 0 
									ifTrue: 
										[rotateImage := Form extent: image height @ image width depth: Display depth.
										(image rotateBy: #left centerAt: 0@0) displayOn: rotateImage.
										image := rotateImage].
								collection add: ratio -> image]].
				xScale := collection]].
	^xScale! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 11/14/1998 12:11'!
yLabel
	| string text pixmap image rotateImage |
	yLabel isNil ifTrue: [Cursor wait
			showWhile: 
				[(string := self model vertical) isNil
					ifTrue: [text := Paragraph withText: Text new style: self textStyle]
					ifFalse: [text := Paragraph withText: string asText style: self textStyle].
				pixmap := Form extent: text boundingBox extent.
				
				text displayOn: pixmap.
				image := pixmap.
				image boundingBox area > 0 
					ifTrue: 
						[rotateImage := Form extent: image height @ image width depth: Display depth.
						(image rotateBy: #left centerAt: 0@0) displayOn: rotateImage.
						image := rotateImage].
				yLabel := image]].
	^yLabel! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 7/18/1998 15:15'!
yScale
	self model log
		ifTrue: [^self yScaleLog]
		ifFalse: [^self yScaleNum]! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 11/14/1998 12:11'!
yScaleLog
	| ranking min max inc collection range pixmap image ratio interval value |
	yScale isNil ifTrue: [Cursor wait
			showWhile: 
				[ranking := self model ranking.
				min := 0.
				max := 0.
				ranking do: [:assoc | max := max max: (assoc value = 0
									ifTrue: [assoc value]
									ifFalse: [assoc value asFloat log])].
				collection := OrderedCollection new.
				max - min > 0
					ifTrue: 
						[inc := 1.
						interval := min to: max by: inc.
						[interval size > 10]
							whileTrue: 
								[inc := inc * 2.
								interval := min to: max by: inc].
						interval
							do: 
								[:each | 
								ratio := each / (max - min).
								range := Paragraph withText: (10 raisedTo: each) printString asText style: self textStyle.
								pixmap := Form extent: range boundingBox extent.
								range displayOn: pixmap.
								image := pixmap.
								collection add: ratio -> image.
								1 to: 3
									do: 
										[:n | 
										value := ((10 raisedTo: each + 1)
													* (n / 4)) asFloat log.
										(min <= value and: [value <= max])
											ifTrue: 
												[ratio := value / (max - min).
												range := Paragraph withText: ' ' asText style: self textStyle.
												pixmap := Form extent: range boundingBox extent.
												
												range displayOn: pixmap.
												image := pixmap.
												collection add: ratio -> image]]]].
				yScale := collection]].
	^yScale! !

!OomPopularityView methodsFor: 'private' stamp: 'nishis 11/14/1998 12:12'!
yScaleNum
	| ranking min max inc collection range pixmap image ratio interval |
	yScale isNil ifTrue: [Cursor wait
			showWhile: 
				[ranking := self model ranking.
				min := 0.
				max := 0.
				ranking do: [:assoc | max := max max: assoc value].
				collection := OrderedCollection new.
				max - min > 0
					ifTrue: 
						[inc := (10 raisedTo: (max - min)) printString size / 100 max: 1.
						interval := min to: max by: inc.
						[interval size > 10]
							whileTrue: 
								[inc := inc * 2.
								interval := min to: max by: inc].
						interval
							do: 
								[:each | 
								ratio := each / (max - min).
								range := Paragraph withText: each asInteger printString asText style: self textStyle.
								pixmap := Form extent: range boundingBox extent depth: Display depth.
								range displayOn: pixmap.
								image := pixmap.
								collection add: ratio -> image]].
				yScale := collection]].
	^yScale! !


!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:26'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext! !

!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:26'!
displayBoxOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
					borderWidth: lineWidth 
					borderColor: aColor 
					insideColor: aColor.
	quadrangle displayOn: graphicsContext! !

!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:08'!
displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: lineWidth color: aColor 
	| aForm aLine |
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: graphicsContext! !

!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:57'!
displayPolylineOn: graphicsContext points: points lineWidth: lineWidth color: aColor 
	| aLinearFit aForm |
	aLinearFit := LinearFit new.
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: graphicsContext! !

!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:29'!
displayRectangleOn: graphicsContext rectangle: rectangle lineWidth: lineWidth color: color
	self displayBoxOn: graphicsContext box: rectangle lineWidth: lineWidth color: color.
	self displayBorderOn: graphicsContext box: rectangle lineWidth: lineWidth color: color! !

!OomPopularityView methodsFor: 'private diplaying' stamp: 'nishis 7/18/1998 17:39'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomPopularityView class
	instanceVariableNames: ''!

!OomPopularityView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomPopularityView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomPopularityView class methodsFor: 'copyright'!
version
	^'010'! !
