'Oom010 (11/18/2001 8:36:14 am)'.!


OomAbstractModel subclass: #OomHistogramModel
	instanceVariableNames: 'sample min max rank histogram vertical horizontal color '
	classVariableNames: 'HistogramMenu '
	poolDictionaries: ''
	category: 'Oom-Interface-Histogram'!
!OomHistogramModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomHistogramModel methodsFor: 'accessing'!
color
	color isNil ifTrue: [color := Color orange].
	^color! !

!OomHistogramModel methodsFor: 'accessing'!
color: colorValue 
	color := colorValue.
	self changed: #histogram! !

!OomHistogramModel methodsFor: 'accessing'!
flush
	histogram := nil! !

!OomHistogramModel methodsFor: 'accessing'!
horizontal
	^horizontal! !

!OomHistogramModel methodsFor: 'accessing'!
horizontal: aString
	horizontal := aString.
	self changed: #description! !

!OomHistogramModel methodsFor: 'accessing'!
max
	| value |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	max isNil
		ifTrue: 
			[value := nil.
			self sample do: [:each | value isNil
					ifTrue: [value := each]
					ifFalse: [value := value max: each]].
			max := value].
	^max! !

!OomHistogramModel methodsFor: 'accessing'!
max: maxValue 
	max := maxValue.
	self flush.
	self changed: #histogram! !

!OomHistogramModel methodsFor: 'accessing'!
min
	| value |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	min isNil
		ifTrue: 
			[value := nil.
			self sample do: [:each | value isNil
					ifTrue: [value := each]
					ifFalse: [value := value min: each]].
			min := value].
	^min! !

!OomHistogramModel methodsFor: 'accessing'!
min: minValue 
	min := minValue.
	self flush.
	self changed: #histogram! !

!OomHistogramModel methodsFor: 'accessing'!
rank
	rank isNil ifTrue: [rank := 10].
	^rank! !

!OomHistogramModel methodsFor: 'accessing'!
rank: rankValue 
	rank := rankValue.
	self flush.
	self changed: #histogram! !

!OomHistogramModel methodsFor: 'accessing'!
sample
	^sample! !

!OomHistogramModel methodsFor: 'accessing'!
sample: aCollection 
	sample := aCollection.
	self flush.
	self changed: #sample! !

!OomHistogramModel methodsFor: 'accessing'!
vertical
	^vertical! !

!OomHistogramModel methodsFor: 'accessing'!
vertical: aString 
	vertical := aString.
	self changed: #description! !


!OomHistogramModel methodsFor: 'functions'!
average
	| count |
	count := self count.
	count = 0 ifTrue: [^0].
	^self total / count! !

!OomHistogramModel methodsFor: 'functions'!
count
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	^self sample size! !

!OomHistogramModel methodsFor: 'functions'!
deviation
	| average count value v |
	average := self average.
	count := self count.
	count = 0 ifTrue: [^0].
	value := 0.
	self sample
		do: 
			[:each | 
			v := each.
			v := v - average.
			v := v * v.
			value := value + v].
	^(value / (count - 1)) sqrt! !

!OomHistogramModel methodsFor: 'functions'!
histogram
	| maximum section |
	histogram notNil ifTrue: [^histogram].
	(self sample isNil or: [self sample isEmpty])
		ifTrue: 
			[histogram := OrderedCollection new.
			^histogram].
	histogram := OrderedCollection new.
	self sections do: [:each | histogram add: each -> 0].
	maximum := self max.
	self sample do: [:each | each = maximum
			ifTrue: [histogram last value: histogram last value + 1]
			ifFalse: [histogram
					do: 
						[:assoc | 
						section := assoc key.
						(section first <= each and: [each < section last])
							ifTrue: [assoc value: assoc value + 1]]]].
	^histogram! !

!OomHistogramModel methodsFor: 'functions'!
maximum
	| maximum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	maximum := nil.
	self sample do: [:each | maximum isNil
			ifTrue: [maximum := each]
			ifFalse: [maximum := maximum max: each]].
	^maximum! !

!OomHistogramModel methodsFor: 'functions'!
minimum
	| minimum |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	minimum := nil.
	self sample do: [:each | minimum isNil
			ifTrue: [minimum := each]
			ifFalse: [minimum := minimum min: each]].
	^minimum! !

!OomHistogramModel methodsFor: 'functions'!
sections
	| collection maximum minimum width start end |
	collection := OrderedCollection new.
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^collection].
	maximum := self max.
	minimum := self min.
	maximum = minimum ifTrue: [^collection].
	width := maximum - minimum / self rank.
	start := minimum.
	end := minimum + width.
	self rank
		timesRepeat: 
			[collection add: (Array with: start with: end).
			start := start + width.
			end := end + width].
	^collection! !

!OomHistogramModel methodsFor: 'functions'!
total
	| total |
	(self sample isNil or: [self sample isEmpty])
		ifTrue: [^0].
	total := 0.
	self sample do: [:each | total := total + each].
	^total! !


!OomHistogramModel methodsFor: 'menu messages'!
changeMax
	| answer |
	answer := FillInTheBlank request: 'max of range?' initialAnswer: self max printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self max ifTrue: [^self].
	self max: answer! !

!OomHistogramModel methodsFor: 'menu messages'!
changeMin
	| answer |
	answer := FillInTheBlank request: 'min of range?' initialAnswer: self min printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self min ifTrue: [^self].
	self min: answer! !

!OomHistogramModel methodsFor: 'menu messages'!
changeRank
	| answer |
	answer := FillInTheBlank request: 'number of ranks?' initialAnswer: self rank printString.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	answer := Compiler evaluate: answer.
	(answer isKindOf: Number)
		ifFalse: [^self].
	answer = self rank ifTrue: [^self].
	self rank: answer! !

!OomHistogramModel methodsFor: 'menu messages' stamp: 'nishis 11/9/1998 10:35'!
showClasses: interval 
	| first last value collection target |
	(self sample respondsTo: #associations)
		ifFalse: [^self].
	first := interval first.
	last := interval last.
	collection := SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key].
	self sample
		associationsDo: 
			[:assoc | 
			value := assoc value.
			last = self max
				ifTrue: [(first <= value and: [value <= last])
						ifTrue: [collection add: assoc]]
				ifFalse: [(first <= value and: [value < last])
						ifTrue: [collection add: assoc]]].
	collection isEmpty ifTrue: [^self].
	target := OomFakeDialog
				model: self
				choose: 'Which of these classes do you browse?'
				fromList: (collection collect: [:assoc | assoc key asString , ' (' , assoc value printString , ')'])
				values: (collection collect: [:assoc | assoc key])
				lines: 10
				cancel: [nil].
	target isNil ifTrue: [^self].
	self showItem: target! !

!OomHistogramModel methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 12:34'!
showItem: target 
	target isNil ifTrue: [^self].
	OomTableMetrics browse: target! !

!OomHistogramModel methodsFor: 'menu messages' stamp: 'nishis 7/18/1998 18:08'!
showItems: interval 
	| first last value collection |
	(self sample isKindOf: Dictionary)
		ifFalse: [^self].
	first := interval first.
	last := interval last.
	collection := SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key].
	self sample
		associationsDo: 
			[:assoc | 
			value := assoc value.
			last = self max
				ifTrue: [(first <= value and: [value <= last])
						ifTrue: [collection add: assoc]]
				ifFalse: [(first <= value and: [value < last])
						ifTrue: [collection add: assoc]]].
	collection isEmpty ifTrue: [^self].
	OomFakeDialog
				model: self
				choose: 'Which of these classes do you browse?'
				fromList: (collection collect: [:assoc | assoc key asString , ' (' , assoc value printString , ')'])
				values: (collection collect: [:assoc | assoc key])
				lines: 10
				cancel: [nil]! !

!OomHistogramModel methodsFor: 'menu messages' stamp: 'nishis 7/18/1998 14:18'!
yellowButtonMenu
	"OomHistogramModel flushMenus."

	| collection menu |
	HistogramMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'min' -> #changeMin.
			collection add: 'max' -> #changeMax.
			collection add:  'rank' -> #changeRank.
			menu := OomMenuMaker fromCollection: collection.
			HistogramMenu := menu].
	^HistogramMenu! !


!OomHistogramModel methodsFor: 'interface opening' stamp: 'nishis 7/18/1998 14:05'!
histogramView
	| aView |
	aView := OomHistogramView new.
	aView model: self.
	^aView! !

!OomHistogramModel methodsFor: 'interface opening' stamp: 'nishis 11/12/1998 22:18'!
open
	"HistogramModel new open"
	| topView view |
	view := self histogramView.
	view  borderWidth: 1.
	topView := OomScheduledView
			model: view model 
			label: 'Histogram' 
			minimumSize: 300 @ 260.
	topView addSubView: view.
	self postBuildWith: topView.
	OomUtilities openReframe: topView! !


!OomHistogramModel methodsFor: 'printing'!
printOn: aStream 
	| collection section count |
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' ('.
	aStream cr.
	aStream nextPutAll: '  histogram:'.
	aStream cr.
	collection := self histogram.
	collection
		do: 
			[:assoc | 
			section := assoc key.
			count := assoc value.
			aStream space; space; space; space.
			aStream nextPutAll: '(over '.
			aStream nextPutAll: section first asFloat printString.
			assoc = collection last
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream nextPutAll: section last asFloat printString.
					aStream nextPutAll: ' and under']
				ifFalse: 
					[aStream nextPutAll: ', '.
					aStream nextPutAll: 'under '.
					aStream nextPutAll: section last asFloat printString].
			aStream nextPutAll: '): '.
			aStream nextPutAll: count printString.
			aStream cr].
	aStream nextPutAll: '  count:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self count printString.
	aStream cr.
	aStream nextPutAll: '  average:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self average asFloat printString.
	aStream cr.
	aStream nextPutAll: '  deviation:'.
	aStream cr.
	aStream space; space; space; space.
	aStream nextPutAll: self deviation asFloat printString.
	aStream cr.
	aStream nextPutAll: ')'! !


!OomHistogramModel methodsFor: 'private'!
sample: aCollection min: minValue max: maxValue rank: rankValue 
	sample := aCollection.
	min := minValue.
	max := maxValue.
	rank := rankValue.
	self flush! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomHistogramModel class
	instanceVariableNames: ''!

!OomHistogramModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomHistogramModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomHistogramModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomHistogramModel class methodsFor: 'class initialization' stamp: 'nishis 7/18/1998 14:47'!
flushMenus
	"OomHistogramModel flushMenus."

	HistogramMenu := nil! !


!OomHistogramModel class methodsFor: 'instance creation'!
sample: aCollection
	^(self new)
		sample: aCollection
		min: nil
		max: nil
		rank: nil; yourself! !

!OomHistogramModel class methodsFor: 'instance creation'!
sample: aCollection min: minValue max: maxValue rank: rankValue 
	^(self new)
		sample: aCollection
		min: minValue
		max: maxValue
		rank: rankValue; yourself! !

!OomHistogramModel class methodsFor: 'instance creation'!
sample: aCollection rank: rankValue 
	^(self new)
		sample: aCollection
		min: nil
		max: nil
		rank: rankValue; yourself! !


!OomHistogramModel class methodsFor: 'examples'!
example1
	"OomHistogramModel example1."

	| collection histogram |
	collection := OrderedCollection new.
	collection add: 0.
	collection add: 10.
	collection add: 20.
	collection add: 30.
	collection add: 35.
	collection add: 40.
	collection add: 45.
	collection add: 48.
	collection add: 50.
	collection add: 52.
	collection add: 55.
	collection add: 60.
	collection add: 65.
	collection add: 70.
	collection add: 80.
	collection add: 90.
	collection add: 100.
	histogram := OomHistogramModel sample: collection.
	Transcript cr; show: histogram printString.
	^histogram! !

!OomHistogramModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 11:39'!
example2
	"OomHistogramModel example2."

	| classes dictionary histogram |
	classes := Magnitude withAllSubclasses.
	dictionary := (OomMetricNOM classes: classes) compute.
	histogram := OomHistogramModel sample: dictionary.
	Transcript cr; show: histogram printString.
	^histogram! !

!OomHistogramModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 11:39'!
example3
	"OomHistogramModel example3."

	| classes dictionary histogram |
	classes := Magnitude withAllSubclasses.
	dictionary := (OomMetricNOM classes: classes) compute.
	histogram := OomHistogramModel
				sample: dictionary
				min: 0
				max: 200
				rank: 20.
	histogram open.
	^histogram! !

!OomHistogramModel class methodsFor: 'examples' stamp: 'nishis 7/18/1998 11:40'!
example4
	"OomHistogramModel example4."

	| classes calculator progress dictionary histogram |
	classes := OomMetricAbstract allClasses.
	calculator := OomMetricNOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [dictionary := calculator compute].
	histogram := OomHistogramModel
				sample: dictionary
				min: 0
				max: 200
				rank: 20.
	histogram horizontal: calculator descriptionAndNickname.
	histogram vertical: 'number of classes'.
	histogram open.
	^histogram! !
