'Oom010 (11/18/2001 8:36:16 am)'.!


OomAbstractModel subclass: #OomDisplayModel
	instanceVariableNames: 'displayObject boundingBox '
	classVariableNames: 'YellowButtonMenu '
	poolDictionaries: ''
	category: 'Oom-Interface-Display'!
!OomDisplayModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomDisplayModel methodsFor: 'accessing'!
visual
	displayObject isNil ifTrue: [self visual: String new asParagraph].
	^displayObject! !

!OomDisplayModel methodsFor: 'accessing'!
visual: anObject 
	| visual |
	(anObject respondsTo: #value)
		ifTrue: [visual := anObject value]
		ifFalse: [visual := anObject].
	visual = displayObject
		ifFalse: 
			[((visual respondsTo: #boundingBox) and: [visual respondsTo: #displayOn:])
				ifTrue: [displayObject := visual]
				ifFalse:
					[visual isNil
						ifTrue: [displayObject := nil]
						ifFalse:
							[(visual isKindOf: String)
								ifTrue: [displayObject := Paragraph
											withText: visual asText
											style: TextStyle default copy]
								ifFalse: [displayObject := Paragraph
											withText: visual printString asText
											style: TextStyle default copy]]].
			self visualIsChanged]! !


!OomDisplayModel methodsFor: 'displaying'!
display
	self displayOn: Display! !

!OomDisplayModel methodsFor: 'displaying'!
displayOn: aDisplayMedium
	self displayOn: aDisplayMedium at: 0 @ 0! !

!OomDisplayModel methodsFor: 'displaying'!
displayOn: aDisplayMedium at: aDisplayPoint 
	self
		displayOn: aDisplayMedium
		at: aDisplayPoint
		clippingBox: aDisplayMedium boundingBox! !

!OomDisplayModel methodsFor: 'displaying' stamp: 'nishis 8/9/1998 02:44'!
displayOn: aDisplayMedium at: aDisplayPoint clippingBox: clipRectangle 
	self visual 
		displayOn: aDisplayMedium
		at: aDisplayPoint
		clippingBox: clipRectangle ! !

!OomDisplayModel methodsFor: 'displaying' stamp: 'nishis 8/18/1998 15:23'!
show
	| displayModel |
	displayModel := OomDisplayModel visual: self.
	self openOn: displayModel label: 'show of ', self printString! !

!OomDisplayModel methodsFor: 'displaying' stamp: 'nishis 8/18/1998 15:23'!
show: labelString
	| displayModel |
	displayModel := OomDisplayModel visual: self.
	self openOn: displayModel label: labelString! !


!OomDisplayModel methodsFor: 'display box access'!
boundingBox
	boundingBox isNil ifTrue: [boundingBox := self computeBoundingBox].
	^boundingBox! !

!OomDisplayModel methodsFor: 'display box access'!
computeBoundingBox
	^self visual boundingBox! !

!OomDisplayModel methodsFor: 'display box access'!
flushBoundingBox
	boundingBox := nil! !


!OomDisplayModel methodsFor: 'interface opening' stamp: 'nishis 8/18/1998 15:20'!
open
	| displayModel |
	displayModel := self visual.
	self openOn: displayModel label: 'OomDisplay'! !

!OomDisplayModel methodsFor: 'interface opening' stamp: 'nishis 8/18/1998 15:23'!
openOn: anObject label: labelString
	| displayModel scheduledView displayView |
	displayModel := anObject.
	scheduledView := OomScheduledView
		model: displayModel
		label: labelString
		minimumSize: 100 @ 100.
	scheduledView controller menuHolder: [self yellowButtonMenu].
	scheduledView controller performer: self.
	displayView := OomDisplayView model: self.
	scheduledView addSubView: displayView.
	scheduledView controller open"At: 100 @ 100".
	^displayModel! !


!OomDisplayModel methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 19:30'!
yellowButtonMenu
	"OomDisplayModel flushMenus."

	| collection menu |
	YellowButtonMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'inspect' -> #inspect.
			menu := OomMenuMaker fromCollection: collection.
			YellowButtonMenu := menu].
	^YellowButtonMenu! !


!OomDisplayModel methodsFor: 'private'!
visualIsChanged
	self changed: #visual! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomDisplayModel class
	instanceVariableNames: ''!

!OomDisplayModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomDisplayModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomDisplayModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomDisplayModel class methodsFor: 'class initialization' stamp: 'nishis 7/29/1998 22:23'!
flushMenus
	"OomDisplayModel flushMenus."

	YellowButtonMenu := nil! !


!OomDisplayModel class methodsFor: 'instance creation'!
visual: anObject 
	^self new visual: anObject! !


!OomDisplayModel class methodsFor: 'examples'!
example1
	"OomDisplayModel example1."

	| displayModel savedDisplay |
	displayModel := OomDisplayModel visual: Form fromUser.
	savedDisplay := Form fromDisplay: displayModel boundingBox.
	displayModel display.
	Cursor crossHair showWhile: [InputSensor default waitClickButton].
	savedDisplay display.
	^displayModel! !

!OomDisplayModel class methodsFor: 'examples'!
example2
	"OomDisplayModel example2."

	| displayModel savedDisplay |
	displayModel := OomDisplayModel visual: (OomDisplayModel class sourceCodeAt: thisContext selector).
	savedDisplay := Form fromDisplay: displayModel boundingBox.
	displayModel display.
	Cursor crossHair showWhile: [InputSensor default waitClickButton].
	savedDisplay display.
	^displayModel! !

!OomDisplayModel class methodsFor: 'examples'!
example3
	"OomDisplayModel example3."

	| displayModel scheduledView displayView |
	displayModel := OomDisplayModel visual: Form fromUser.
	scheduledView := OomScheduledView
		model: displayModel
		label: 'OomDisplay'
		minimumSize: 300 @ 200.
	displayView := OomDisplayView model: displayModel.
	scheduledView addSubView: displayView.
	scheduledView controller openAt: 100 @ 100! !

!OomDisplayModel class methodsFor: 'examples'!
example4
	"OomDisplayModel example4."

	| displayModel scheduledView displayView |
	displayModel := OomDisplayModel visual: (OomDisplayModel class sourceCodeAt: thisContext selector).
	scheduledView := OomScheduledView
		model: displayModel
		label: 'OomDisplay'
		minimumSize: 300 @ 200.
	displayView := OomDisplayView model: displayModel.
	scheduledView addSubView: displayView.
	scheduledView controller openAt: 100 @ 100! !

!OomDisplayModel class methodsFor: 'examples'!
example5
	"OomDisplayModel example5."

	| displayModel scheduledView displayView displayView2 |
	displayModel := OomDisplayModel visual: (Form fromDisplay: (0 @ 0 extent: 300 @ 200)).
	scheduledView := OomScheduledView
		model: displayModel
		label: 'OomDisplay'
		minimumSize: 300 @ 200.
	displayView := OomDisplayView model: displayModel.
	scheduledView addSubView: displayView.
	displayView2 := OomDisplayView model: displayModel.
	scheduledView addSubView: displayView2 below: displayView.
	scheduledView controller openAt: 100 @ 100! !


!OomDisplayModel class methodsFor: 'private' stamp: 'nishis 7/20/1998 04:58'!
displayBorderOn: graphicsContext box: aRectangle
	self displayBorderOn: graphicsContext box: aRectangle lineWidth: 1 color: Color black! !

!OomDisplayModel class methodsFor: 'private' stamp: 'nishis 7/20/1998 04:57'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext! !

!OomDisplayModel class methodsFor: 'private' stamp: 'nishis 7/20/1998 04:58'!
displayLineOn: graphicsContext from: fromPoint to: toPoint 
	self displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: 1 color: Color black! !

!OomDisplayModel class methodsFor: 'private' stamp: 'nishis 7/20/1998 04:57'!
displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: lineWidth color: aColor 
	| aForm aLine |
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: graphicsContext! !
