'Oom010 (11/18/2001 8:36:17 am)'.!


View subclass: #OomButtonView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Button'!
!OomButtonView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomButtonView methodsFor: 'initialize-release' stamp: 'nishis 10/21/1998 00:47'!
release
	super release! !


!OomButtonView methodsFor: 'controller accessing'!
defaultControllerClass
	^OomButtonController! !


!OomButtonView methodsFor: 'displaying' stamp: 'nishis 11/12/1998 23:20'!
displayView
	| graphicsContext |
	self isObscured ifTrue: [^nil].
	graphicsContext := Form extent: self insetDisplayBox extent depth: Display depth.
	self model isEnabled 
		ifTrue: 
			[self model value = true
				ifTrue: [self displayTrueOn: graphicsContext]
				ifFalse: [self displayFalseOn: graphicsContext]]
		ifFalse: 
			[self displayDisabledOn: graphicsContext]
! !


!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/25/1998 14:46'!
displayAreaOn: graphicsContext 
	| visibleAreas |
	visibleAreas := self visibleAreas.
	visibleAreas 
		do: 
			[:rectangle | 
			graphicsContext
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 8/16/1998 07:15'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: aRectangle 
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 1/23/1999 16:52'!
displayButtonOn: graphicsContext borderColor: theBorderColor visualForegroundColor: visualForegroundColor visualBackgroundColor: visualBackgroundColor  topLeftColor: topLeftColor bottomRightColor: bottomRightColor fillWithColor: fillWithColor offset: offset
	| box visual offsetPosition |
	offsetPosition := 0.
	offset = #pressed ifTrue: [offsetPosition := 1].
	offset = #true ifTrue: [offsetPosition := 0].
	offset = #false ifTrue: [offsetPosition := -1].
	box := 0 @ 0 extent: self insetDisplayBox extent.
	graphicsContext fillWithColor: fillWithColor.
	self displayRectangularBorderOn: graphicsContext border: box color: theBorderColor.
	visual := self model visual.
	(visual respondsTo: #foregroundColor:backgroundColor:) 
		ifTrue: 
			[visual 
				foregroundColor: visualForegroundColor 
				backgroundColor: visualBackgroundColor.
			visual displayOn: graphicsContext at: box center - visual boundingBox center + offsetPosition]
		ifFalse: 
			[self model isEnabled 
				ifTrue: [visual displayOn: graphicsContext at: box center - visual boundingBox center + offsetPosition]
				ifFalse: [visual displayOn: graphicsContext at: box center - visual boundingBox center rule: Form under]].
	
	self displayLineOn: graphicsContext from: box topLeft + (0 @ 0) to: box topRight + (-1 @ 0) lineWidth: 2 color: topLeftColor.
	self displayLineOn: graphicsContext from: box topLeft + (0 @ 0) to: box bottomLeft + (0 @ -1) lineWidth: 2 color: topLeftColor.
	self displayLineOn: graphicsContext from: box bottomLeft + (0 @ -1) to: box bottomRight + (-1 @ -1) lineWidth: 21 color: bottomRightColor.
	self displayLineOn: graphicsContext from: box topRight + (-1 @ 0) to: box bottomRight + (-1 @ -1) lineWidth: 2 color: bottomRightColor.
	self displayAreaOn: graphicsContext! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/25/1998 15:31'!
displayDisabledOn: graphicsContext 
	self 
		displayButtonOn: graphicsContext 
		borderColor: (Color gray: 0.7) 
		visualForegroundColor: (Color gray: 0.5) 
		visualBackgroundColor: (Color gray: 0.7) 
		topLeftColor: (Color gray: 0.8) 
		bottomRightColor: (Color gray: 0.2) 
		fillWithColor: (Color gray: 0.7) 
		offset: #disabled! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/26/1998 01:48'!
displayFalseOn: graphicsContext 
	self 
		displayButtonOn: graphicsContext 
		borderColor: (Color gray: 0.7) 
		visualForegroundColor: Color black 
		visualBackgroundColor: (Color gray: 0.7) 
		topLeftColor: (Color gray: 0.8) 
		bottomRightColor: (Color gray: 0.2) 
		fillWithColor: (Color gray: 0.7) 
		offset: #false! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/25/1998 02:48'!
displayLineOn: graphicsContext from: fromPoint to: toPoint lineWidth: lineWidth color: aColor 
	| aForm aLine |
	aForm := Form extent: lineWidth @ lineWidth depth: Display depth.
	aForm fillColor: aColor.
	aLine := Line new.
	aLine form: aForm.
	aLine beginPoint: fromPoint; endPoint: toPoint; displayOn: graphicsContext! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/26/1998 01:48'!
displayPressedOn: graphicsContext 
	self 
		displayButtonOn: graphicsContext 
		borderColor: (Color gray: 0.3) 
		visualForegroundColor: Color black 
		visualBackgroundColor: (Color gray: 0.3)
		topLeftColor: (Color gray: 0.2) 
		bottomRightColor: (Color gray: 0.8) 
		fillWithColor: (Color gray: 0.3) 
		offset: #pressed! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/25/1998 02:45'!
displayRectangularBorderOn: graphicsContext border: box color: aColor
	self displayBorderOn: graphicsContext box: box lineWidth: 1 color: aColor! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/26/1998 01:48'!
displayTrueOn: graphicsContext 
	self 
		displayButtonOn: graphicsContext 
		borderColor: (Color gray: 0.3) 
		visualForegroundColor: Color black 
		visualBackgroundColor: (Color gray: 0.3)  
		topLeftColor: (Color gray: 0.2) 
		bottomRightColor: (Color gray: 0.8) 
		fillWithColor: (Color gray: 0.3) 
		offset: #true! !

!OomButtonView methodsFor: 'private displaying' stamp: 'nishis 7/25/1998 02:41'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !


!OomButtonView methodsFor: 'updating' stamp: 'nishis 7/25/1998 14:42'!
update: aParameter 
	self displayView! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomButtonView class
	instanceVariableNames: ''!

!OomButtonView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomButtonView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomButtonView class methodsFor: 'copyright'!
version
	^'010'! !
