'Oom010 (11/18/2001 8:36:20 am)'.!


OomTableModel subclass: #OomTableMetrics
	instanceVariableNames: 'classSelector timeStamp readOnly '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Support'!
!OomTableMetrics commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomTableMetrics methodsFor: 'initialize-release' stamp: 'nishis 7/19/1998 12:12'!
initialize
	self timeStamp.
	self readOnly: false! !


!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:12'!
flushMetrics
	table := nil! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 11/13/1998 17:45'!
formatTable
	^self subclassResponsibility! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:12'!
metricClasses
	^self subclassResponsibility! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:12'!
readOnly
	^readOnly = true! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:12'!
readOnly: aBoolean 
	readOnly := aBoolean = true! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:24'!
table
	table isNil ifTrue: [self computeMetrics].
	^table! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:13'!
timeStamp
	timeStamp isNil ifTrue: [timeStamp := OomTimeStamp new stamp].
	^timeStamp! !

!OomTableMetrics methodsFor: 'accessing' stamp: 'nishis 7/19/1998 12:13'!
timeStamp: timeStampString 
	timeStamp := timeStampString asString! !


!OomTableMetrics methodsFor: 'class accessing' stamp: 'nishis 7/19/1998 12:14'!
classNames
	^self classSelector classNames! !

!OomTableMetrics methodsFor: 'class accessing' stamp: 'nishis 7/19/1998 12:14'!
classNames: classNameCollection 
	self classSelector classNames: classNameCollection! !

!OomTableMetrics methodsFor: 'class accessing' stamp: 'nishis 7/19/1998 12:14'!
classSelector
	classSelector isNil ifTrue: [classSelector := OomClassSelector new].
	^classSelector! !

!OomTableMetrics methodsFor: 'class accessing' stamp: 'nishis 7/19/1998 12:13'!
classes
	| classes it |
	classes := OrderedCollection new: self classNames size.
	self classNames
		do: 
			[:each | 
			it := Smalltalk at: each ifAbsent: [nil].
			((it isKindOf: Behavior) and: [it isMeta not])
				ifTrue: [classes add: it]].
	^classes! !

!OomTableMetrics methodsFor: 'class accessing' stamp: 'nishis 7/20/1998 03:53'!
classes: classCollection 
	self classNames: ((classCollection select: [:each | each isMeta not])
			collect: [:each | each name])! !


!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 12:15'!
actionOnColumn: aString 
	| column dictionary values keys |
	column := (self table atRow: 1)
				findFirst: [:each | each asString = aString].
	column < 1 ifTrue: [^nil].
	values := self table atColumn: column.
	values := values copyFrom: 2 to: values size.
	keys := self table atColumn: 1.
	keys := keys copyFrom: 2 to: keys size.
	dictionary := IdentityDictionary new: keys size.
	keys with: values do: [:key :value | dictionary at: key asSymbol put: value].
	^self class histogram: dictionary nickname: aString! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 7/19/1998 12:15'!
actionOnRow: aString 
	self class browse: aString! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 7/20/1998 03:54'!
computeValues
	(self classSelector classNames isEmpty and: [self classSelector class cache notNil])
		ifTrue: [self classSelector classNames: self classSelector class cache].
	self flushMetrics.
	self computeMetrics.
	self changed: #table! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 11/19/1998 00:01'!
loadValues
	| answer stream fileNameSuffixBlock index extention prompt filename path |
	(self class name beginsWith: self class system) 
		ifTrue: [prompt := self class name copyFrom: self class system size + 1 to: self class name size]
		ifFalse: [prompt := self class name].
	prompt := ' <<< ' , prompt , ' >>> ' , String cr , 'Choose a file'.
	fileNameSuffixBlock := [:name | 
			index := name findLast: [:c | c = FileDirectory extensionDelimiter].
			(index = 0 or: [index = name size]) 
				ifTrue: ['*']
				ifFalse: [name copyFrom: index + 1 to: name size]].
	answer := FillInTheBlank request: 'Please type a file name:' initialAnswer: self defaultFileName.
	(FileDirectory default includesKey: answer)
		ifFalse: 
			[extention := fileNameSuffixBlock value: answer.
			answer := self chooseFileWithSuffix: extention prompt: prompt].
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	path := FileDirectory dirPathFor: answer.
	filename := (path isEmpty or: [path isNil]) 
			ifTrue: [answer asFileName]
			ifFalse: [answer].
	stream := FileStream oldFileNamed: filename.
	[Cursor read showWhile: [self loadMetrics: stream]]
		ifError: [:err :rcvr | stream close].
	stream close.
	self changed! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 11/13/1998 19:16'!
saveValues
	| answer stream |
	answer := FillInTheBlank request: 'Save as file named:' initialAnswer: self defaultFileName.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	stream := FileStream newFileNamed: answer asFileName.
	[Cursor write showWhile: [self saveMetrics: stream]]
		ifError: [:err :rcvr | stream close].
	stream close
! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 11/14/1998 12:34'!
saveValuesAsHtml
	| answer stream |
	answer := FillInTheBlank request: 'Save as html file named:' initialAnswer: self defaultHtmlFileName.
	(answer isNil or: [answer isEmpty])
		ifTrue: [^self].
	stream := FileStream newFileNamed: answer asFileName.
	[Cursor write showWhile: [self saveMetricsAsHtml: stream]]
		ifError: [:err :rcvr | stream close].
	stream close
! !

!OomTableMetrics methodsFor: 'menu messages' stamp: 'nishis 7/29/1998 03:39'!
selectClasses
	| model topView |
	model := self classSelector.
	model dependents size = 0 
		ifTrue: 
			[model postBuildBlock: [:aBuilder | aBuilder label: 'Class Sellector'].
			model open]
		ifFalse: 
			[model dependents do: [:view | view isTopView ifTrue: [topView := view]].
			topView isNil not ifTrue: [ScheduledControllers activateController: topView controller]]! !


!OomTableMetrics methodsFor: 'filing' stamp: 'nishis 11/7/1998 04:33'!
loadMetrics: aStream 
	| utility separators string collection rowSize columnSize matrix value |
	utility := OomMetricAbstract new.
	separators := String
				with: Character tab
				with: Character cr
				with: Character linefeed.
	string := (utility separate: (utility getLine: aStream)
				dividers: separators) first.
	string = self class name asString
		ifFalse: 
			[self inform: 'This is an instance of ' , string.
			^self].
	string := (utility separate: (utility getLine: aStream)
				dividers: separators) first.
	timeStamp := string.
	collection := utility separate: (utility getLine: aStream)
				dividers: separators.
	rowSize := (collection at: 1) asNumber.
	columnSize := (collection at: 2) asNumber.
	matrix := OomMatrix new: rowSize by: columnSize.
	1 to: rowSize
		do: 
			[:i | 
			collection := utility separate: (utility getLine: aStream)
						dividers: separators.
			matrix rowIndex: i
				doJ: 
					[:v :j | 
					value := collection at: j.
					i = 1
						ifTrue: [value := value asText allBold]
						ifFalse: [j = 1 ifFalse: [value := value asNumber]].
					matrix atPoint: i @ j put: value]].
	readOnly := true.
	self table: matrix.
	self updateClassSelector! !

!OomTableMetrics methodsFor: 'filing' stamp: 'nishis 7/19/1998 12:17'!
saveMetrics: aStream 
	aStream nextPutAll: self class name asString.
	aStream cr.
	aStream nextPutAll: self timeStamp asString.
	aStream cr.
	aStream nextPutAll: self table rowSize printString.
	aStream tab.
	aStream nextPutAll: self table columnSize printString.
	aStream cr.
	1 to: self table rowSize
		do: 
			[:index | 
			self table rowIndex: index
				do: 
					[:each | 
					(each isKindOf: Number)
						ifTrue: [(each isKindOf: Integer)
								ifTrue: [aStream nextPutAll: each printString]
								ifFalse: [aStream nextPutAll: each asFloat printString]]
						ifFalse: [aStream nextPutAll: each asString].
					aStream tab].
			aStream cr]! !

!OomTableMetrics methodsFor: 'filing' stamp: 'nishis 11/8/1998 23:43'!
saveMetricsAsHtml: aStream 
	self htmlHeader: aStream.
	self htmlBody: aStream.
	self htmlFooter: aStream! !


!OomTableMetrics methodsFor: 'utilities' stamp: 'nishis 11/7/1998 04:15'!
chooseFileWithSuffix: aSuffix
	^self chooseFileWithSuffix: aSuffix prompt: 'Choose a file'! !

!OomTableMetrics methodsFor: 'utilities' stamp: 'nishis 11/7/1998 04:14'!
chooseFileWithSuffix: aSuffix prompt: message
	^self class chooseFileWithSuffix: aSuffix prompt: message! !

!OomTableMetrics methodsFor: 'utilities' stamp: 'nishis 11/7/1998 02:38'!
classNamesFromTable: aTable
	| classNames |
	classNames := OrderedCollection new.
	Cursor wait
		showWhile: 
			[aTable columnIndex: 1 doI: 
					[:each :i | (each isMemberOf: String) ifTrue: [classNames add: each asSymbol]]].
	^classNames! !


!OomTableMetrics methodsFor: 'private' stamp: 'nishis 10/7/1998 23:40'!
computeMetrics
	| classes metrics matrix progress column calculator result keys values |
	classes := self classes.
	metrics := self metricClasses.
	classes isEmpty
		ifTrue: [matrix := OomMatrix
						new: 1
						by: metrics size + 1
						collection: (Array with: metrics first item asText allBold)
								, (metrics collect: [:each | each nickname asText allBold])]
		ifFalse: 
			[matrix := OomMatrix new: classes size + 1 by: metrics size + 1.
			progress := OomProgress new.
			progress
				do: 
					[column := 2.
					metrics
						do: 
							[:aClass | 
							calculator := aClass classes: classes.
							self setEnvironment: calculator.
							progress message: calculator nickname , ' computing...'.
							calculator interim: [:index :size | size > 0 ifTrue: [progress value: index / size]].
							result := calculator compute.
							result := calculator convertToMatrix: result.
							column = 2
								ifTrue: 
									[keys := result atColumn: 1.
									1 to: keys size do: [:i | matrix atPoint: i @ 1 put: (keys at: i)]].
							values := result atColumn: 2.
							1 to: values size do: [:i | matrix atPoint: i @ column put: (values at: i)].
							column := column + 1]]].
	table := matrix! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 7/19/1998 12:30'!
defaultFileName
	| utility collection string str |
	utility := OomMetricAbstract new.
	collection := utility separate: OomTimeStamp new stamp dividers: utility separators , '/:'.
	string := String new.
	1 to: 3
		do: 
			[:index | 
			str := collection at: index.
			index = 1 ifTrue: [str := str copyFrom: str size - 1 to: str size].
			string := string , str].
	string := self filePrefix , string , '.oom'.
	^string! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/8/1998 22:45'!
defaultHtmlFileName
	| index string |
	index := self defaultFileName reversed indexOf: FileDirectory extensionDelimiter ifAbsent: [0].
	string := (self defaultFileName reversed copyFrom: index + 1 to: self defaultFileName size) reversed.
	^string , FileDirectory dot , 'htm'! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 7/19/1998 12:19'!
filePrefix
	^String new! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/13/1998 18:02'!
htmlBody: aStream 
	| rowPos numberTable |
	numberTable := self formatTable.
	aStream cr.
	aStream nextPutAll: '<H2>'.
	aStream nextPutAll: self class name asString.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream nextPutAll: '<H3>'.
	aStream nextPutAll: self timeStamp asString.
	aStream nextPutAll: '</H3>'.
	aStream cr.

	aStream cr.
	1 to: self table rowSize
		do: 
			[:index | 
			rowPos := 1.
			self table rowIndex: index
				do: 
					[:each | 
					rowPos = 1 ifTrue: 
							[index = 1 
								ifTrue: 
									[aStream nextPutAll: '<TABLE BORDER=1 CELLPADDING="4">'.
									aStream cr].
							aStream nextPutAll: '<TR>'.
							aStream cr].
					index = 1 
						ifTrue: [aStream nextPutAll: '<TH>']
						ifFalse: 
							[rowPos = 1 
								ifTrue: [aStream nextPutAll: '<TD>']
								ifFalse: [aStream nextPutAll: '<TD ALIGN="RIGHT">']].
					(each isKindOf: Number)
						ifTrue: [((each isKindOf: Integer) and: [(numberTable at: rowPos) isKindOf: Integer])
								ifTrue: [aStream nextPutAll: each printString]
								ifFalse: [aStream nextPutAll: (OomUtilities asFloat: each asFloat decimalCount: 2)]]
						ifFalse: [aStream nextPutAll: each asString].
					index = 1 
						ifTrue: [aStream nextPutAll: '</TH>']
						ifFalse: 
							[rowPos = 1 
								ifTrue: [aStream nextPutAll: '</TD>']
								ifFalse: [aStream nextPutAll: '</TD>']].
					rowPos = self table columnSize ifTrue: 
							[aStream nextPutAll: '</TR>'.
							aStream cr].
					rowPos := rowPos + 1].
			aStream cr].
	aStream cr.
	aStream nextPutAll: '</TABLE>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/8/1998 23:45'!
htmlFooter: aStream 
	aStream nextPutAll: '</BODY>'.
	aStream cr.
	aStream nextPutAll: '</HTML>'.
	aStream cr! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/13/1998 18:50'!
htmlHeader: aStream 
	self htmlHeader: aStream title: self class name asString! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/13/1998 18:50'!
htmlHeader: aStream title: aString
	aStream nextPutAll: '<HTML>'.
	aStream cr.
	aStream nextPutAll: '<HEAD>'.
	aStream cr.
	aStream nextPutAll: '<TITLE>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: '</TITLE>'.
	aStream cr.
	aStream nextPutAll: '</HEAD>'.
	aStream cr.
	aStream nextPutAll: '<BODY>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 7/19/1998 12:19'!
setEnvironment: calculator 
	^self! !

!OomTableMetrics methodsFor: 'private' stamp: 'nishis 11/13/1998 18:38'!
updateClassSelector 
	self classSelector inputField contents: '*'.
	self classSelector inputFieldChange: nil.	"self classSelector controller."
	self classSelector selectAllChoice.
	self classSelector removeChoice.
	self classSelector deselectAllCandidate.
	self classNames: (self classNamesFromTable: self table).
	self classSelector inputField changed.
	self classSelector changed! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomTableMetrics class
	instanceVariableNames: ''!

!OomTableMetrics class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomTableMetrics class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomTableMetrics class methodsFor: 'copyright'!
version
	^'010'! !


!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 7/19/1998 12:01'!
browse: aSymbol 
	"OomTableMetrics browse: #Array."
	"OomTableMetrics browse: #at:put:."

	| aClass aList |
	(aClass := self browseClass: aSymbol) isNil
		ifTrue: 
			[(aList := Smalltalk allImplementorsOf: aSymbol asSymbol) isEmpty ifTrue: [^nil].
			Smalltalk browseMessageList: aList name: 'Implementors of ' , aSymbol.
			^aSymbol].
	^aClass! !

!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 7/19/1998 12:01'!
browseClass: argument 
	"OomTableMetrics browseClass: Association."
	"OomTableMetrics browseClass: #Association."
	"OomTableMetrics browseClass: Association class."
	"OomTableMetrics browseClass: 'Association'."

	| target browser |
	(argument isKindOf: Behavior)
		ifTrue: [argument isMeta
				ifTrue: [target := argument soleInstance]
				ifFalse: [target := argument]]
		ifFalse: 
			[target := Smalltalk at: argument asSymbol ifAbsent: [nil].
			target isNil ifTrue: [^nil]].
	browser := HierarchyBrowser new initHierarchyForClass: target meta: true.
	Browser openBrowserView: (browser openSystemCatEditString: nil) label: target printString,  ' hierarchy'. 
	^target! !

!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 11/7/1998 04:10'!
chooseFileWithSuffix: aSuffix
	"OomTableMetrics chooseFileWithSuffix: '*'."
	"OomTableMetrics chooseFileWithSuffix: '.oom'."

	^self chooseFileWithSuffix: aSuffix prompt: 'Choose a file'
! !

!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 11/7/1998 04:12'!
chooseFileWithSuffix: aSuffix prompt: message
	"OomTableMetrics chooseFileWithSuffix: '*' prompt: 'select file'."
	"OomTableMetrics chooseFileWithSuffix: '.oom' prompt: 'select oom file'."

	| aList aName directory folderString suffix |
	folderString := ' [...]'.
	directory := FileDirectory default.
	suffix := aSuffix.
	(suffix beginsWith: FileDirectory dot) ifFalse: [suffix := FileDirectory dot , suffix].
	[true] 
		whileTrue: 
			[aList := SortedCollection new.
			aList addAll: (directory fileNamesMatching: '*', suffix).
			aList addAll: (directory directoryNames collect: [:entry | entry, folderString]).
			aList add: folderString.
			aList size > 0
				ifTrue:
					[aName := (SelectionMenu selections: aList asArray) 
								startUpWithCaption: message.
					aName isNil ifTrue: [^nil].
					(aName endsWith: folderString)
						ifTrue: 
							[aName := aName copyFrom: 1 to: aName size - folderString size.
							aName isEmpty 
								ifTrue: 
									[directory := directory containingDirectory]
								ifFalse: 
									[directory pathName isEmpty 
										ifTrue: [directory := FileDirectory on: aName]
										ifFalse: [directory := directory directoryNamed: aName]]]
						ifFalse: [^directory fullNameFor: aName]]
				ifFalse:
					[self inform: 'Sorry, there are no files
whose names end with "', aSuffix, '".'.
					^nil]]! !

!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 7/19/1998 12:01'!
histogram: aDictionary horizontal: aString 
	"OomTableMetrics 
	histogram: (OomMetricNOM classes: Magnitude withAllSubclasses) compute 
	horizontal: OomMetricNOM descriptionAndNickname."
	"OomTableMetrics 
	histogram: (OomMetricLOC classes: Magnitude withAllSubclasses) compute 
	horizontal: OomMetricLOC descriptionAndNickname."
	"OomTableMetrics 
	histogram: (OomMetricWMC classes: Magnitude withAllSubclasses) compute 
	horizontal: OomMetricWMC descriptionAndNickname."

	| max inc tmp rank histogram |
	max := 10.
	aDictionary do: [:each | max := max max: each asInteger].
	"inc := 10 ** (max log asInteger + 1) // 10."
	inc := (10 raisedTo: (max asFloat log asInteger + 1)) // 10.
	tmp := inc.
	[max > tmp]
		whileTrue: [tmp := tmp + inc].
	max := tmp.
	rank := max // (max // 10 max: 1).
	histogram := OomHistogramModel
				sample: aDictionary
				min: 0
				max: max
				rank: rank.
	histogram horizontal: aString.
	histogram vertical: 'number of classes'.
	histogram open.
	^histogram! !

!OomTableMetrics class methodsFor: 'utilities' stamp: 'nishis 7/19/1998 12:01'!
histogram: aDictionary nickname: aString 
	"OomTableMetrics 
		histogram: (OomMetricNOM classes: Object withAllSubclasses) compute 
		nickname: 'NOM'."

	| collection index |
	collection := OomMetricAbstract withAllSubclasses asOrderedCollection.
	index := collection findFirst: [:each | each nickname = aString].
	index < 1 ifTrue: [^nil].
	^self histogram: aDictionary horizontal: (collection at: index) descriptionAndNickname! !
