'Oom010 (11/18/2001 8:36:22 am)'.!


Object subclass: #OomMetricAbstract
	instanceVariableNames: 'classes interim '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Abstract'!
!OomMetricAbstract commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricAbstract methodsFor: 'accessing'!
behaviors
	^self classes , (self classes collect: [:each | each class])! !

!OomMetricAbstract methodsFor: 'accessing'!
classes
	classes isNil ifTrue: [classes := self class allClasses].
	^classes! !

!OomMetricAbstract methodsFor: 'accessing'!
classes: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	classes := collection! !

!OomMetricAbstract methodsFor: 'accessing'!
interim
	interim isNil ifTrue: [interim := [:index :size | nil]].
	^interim! !

!OomMetricAbstract methodsFor: 'accessing'!
interim: aBlock 
	interim := aBlock! !


!OomMetricAbstract methodsFor: 'computing'!
compute
	^self subclassResponsibility! !


!OomMetricAbstract methodsFor: 'reporting'!
report1: aDictionary 
	self class report1: aDictionary! !

!OomMetricAbstract methodsFor: 'reporting'!
report1: aDictionary on: aStream
	self class report1: aDictionary on: aStream! !

!OomMetricAbstract methodsFor: 'reporting'!
report2: aDictionary 
	self class report2: aDictionary! !

!OomMetricAbstract methodsFor: 'reporting'!
report2: aDictionary on: aStream 
	self class report2: aDictionary on: aStream! !

!OomMetricAbstract methodsFor: 'reporting'!
report: aDictionary 
	self class report: aDictionary! !

!OomMetricAbstract methodsFor: 'reporting'!
report: aDictionary on: aStream 
	self class report: aDictionary on: aStream! !


!OomMetricAbstract methodsFor: 'description'!
description
	^self class description! !

!OomMetricAbstract methodsFor: 'description'!
descriptionAndNickname
	^self class descriptionAndNickname! !

!OomMetricAbstract methodsFor: 'description'!
item
	^self class item! !

!OomMetricAbstract methodsFor: 'description'!
nickname
	^self class nickname! !

!OomMetricAbstract methodsFor: 'description'!
nicknameAndDescription
	^self class nicknameAndDescription! !


!OomMetricAbstract methodsFor: 'converting'!
convertToMatrix: aDictionary
	^self class convertToMatrix: aDictionary! !


!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 1/23/1999 18:05'!
addLiteral: literal to: literalSet
	literalSet add: literal.
	(literal isMemberOf: Array) ifTrue:
		[literal do: [:element | self addLiteral: element to: literalSet]]! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 1/23/1999 18:04'!
allLiterals: aMethod
	| literalSet copyLitral |
	literalSet := IdentitySet new.
	self 
		withAllBlockMethodsDo:
			[:method | method literals 
				do: 
					[:literal | 
					copyLitral := literal copy.
					"Plugin primitive without module:, returns literal including nil.
					for example,
					(FFT compiledMethodAt: #pluginTransformData:) literals inspect."
					((copyLitral isMemberOf: Array) and: [copyLitral size = 4])
						ifTrue: 
							[(copyLitral first isNil) 
								ifTrue: 
									[copyLitral at: 1 put: #unknownModule]].
					self addLiteral: copyLitral to: literalSet]]
		with: aMethod.
	^literalSet! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 5/17/98 21:09'!
associations: aCollection
	^self class associations: aCollection! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 5/17/98 22:03'!
getChar: aStream 
	| char |
	aStream atEnd
		ifTrue: [char := nil]
		ifFalse: 
			[char := aStream next.
			(char = Character cr and: [aStream peek = Character linefeed])
				ifTrue: [aStream next].
			char = Character linefeed ifTrue: [char := Character cr].
			char = Character cr
				ifTrue: 
					[aStream peek = Character linefeed ifTrue: [aStream next].
					char := Character cr]].
	^char! !

!OomMetricAbstract methodsFor: 'private'!
getLine: aStream 
	| stream char |
	stream := WriteStream on: (String new: 128).
	char := self getChar: aStream.
	[char notNil and: [char ~= Character cr]]
		whileTrue: 
			[stream nextPut: char.
			char := self getChar: aStream].
	(char notNil and: [char = Character cr])
		ifTrue: [stream nextPut: char].
	^stream contents! !

!OomMetricAbstract methodsFor: 'private'!
getLines: aStream 
	| lines |
	lines := OrderedCollection new.
	[aStream atEnd]
		whileFalse: [lines add: (self getLine: aStream)].
	^lines! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 5/17/98 23:52'!
isVariableBinding: literal
	^((literal respondsTo: #value) 
		and: [literal respondsTo: #value:]) 
		and: [literal respondsTo: #key]! !

!OomMetricAbstract methodsFor: 'private'!
separate: separateCollection dividers: dividerCollection 
	"OomMetricAbstract new separate: #(a b c d e f g h) dividers: #(d f)."

	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(dividerCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!OomMetricAbstract methodsFor: 'private'!
separators
	"OomMetricAbstract new separators."

	| stream |
	stream := WriteStream on: (String new: 4).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	^stream contents! !

!OomMetricAbstract methodsFor: 'private'!
stringMatch: string and: pattern 
	"OomMetricAbstract new stringMatch: 'Jun Aoki' and: 'Ju*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!OomMetricAbstract methodsFor: 'private'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 5/17/98 22:08'!
values: aDictionary
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aDictionary size.
	aDictionary do: [:value | anOrderedCollection add: value].
	^anOrderedCollection! !

!OomMetricAbstract methodsFor: 'private' stamp: 'nishis 11/11/1998 01:52'!
withAllBlockMethodsDo: aBlock with: aCompileMethod
	"| literalClass |"
	aBlock value: aCompileMethod.
	"never fall on Smalltalk-80."
	"aCompileMethod literals do:
		[:literal | 
		literalClass := literal class.
		literalClass == CompiledMethod
			ifTrue: [self withAllBlockMethodsDo: aBlock with: literal]
			ifFalse:
				[literalClass == BlockContext
					ifTrue: [self withAllBlockMethodsDo: aBlock with: literal method]]]"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricAbstract class
	instanceVariableNames: ''!

!OomMetricAbstract class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricAbstract class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricAbstract class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricAbstract class methodsFor: 'description'!
description
	^String new! !

!OomMetricAbstract class methodsFor: 'description'!
descriptionAndNickname
	^self description , ' (' , self nickname , ')'! !

!OomMetricAbstract class methodsFor: 'description'!
item
	^'class name'! !

!OomMetricAbstract class methodsFor: 'description'!
itemStringSelector
	^#asString! !

!OomMetricAbstract class methodsFor: 'description'!
nickname
	^String new! !

!OomMetricAbstract class methodsFor: 'description'!
nicknameAndDescription
	^self nickname , ': ' , self description! !


!OomMetricAbstract class methodsFor: 'instance creation'!
class: aClass 
	^self classes: (Array with: aClass); yourself! !

!OomMetricAbstract class methodsFor: 'instance creation'!
classes: classCollection 
	^(super new) classes: classCollection; yourself! !


!OomMetricAbstract class methodsFor: 'accessing'!
allBehaviors
	"OomMetricAbstract allBehaviors."

	| collection |
	collection := OrderedCollection new: 2048.
	self allBehaviorsDo: [:each | collection add: each].
	^collection! !

!OomMetricAbstract class methodsFor: 'accessing'!
allClasses
	"OomMetricAbstract allClasses."

	| collection |
	collection := OrderedCollection new: 1024.
	self allClassesDo: [:each | collection add: each].
	^collection! !


!OomMetricAbstract class methodsFor: 'enumerating' stamp: 'nishis 5/17/98 20:46'!
allBehaviorsDo: aBlock 
	"
	| collection | 
	collection := SortedCollection new. 
	collection sortBlock: [:x :y | x name < y name]. 
	OomMetricAbstract allBehaviorsDo: [:each | collection add: each]. 
	^collection 
	"

	"Class" self rootsOfTheWorld
		do: 
			[:aClass | 
			aBlock value: aClass.
			aClass allSubclassesDo: aBlock]! !

!OomMetricAbstract class methodsFor: 'enumerating' stamp: 'nishis 5/17/98 20:46'!
allClassesDo: aBlock 
	"
	| collection | 
	collection := SortedCollection new. 
	collection sortBlock: [:x :y | x name < y name]. 
	OomMetricAbstract allClassesDo: [:each | collection add: each]. 
	^collection 
	"

	"Class" self rootsOfTheWorld do: [:aClass | aClass isMeta not
			ifTrue: 
				[aBlock value: aClass.
				aClass allSubclassesDo: [:each | each isMeta not ifTrue: [aBlock value: each]]]]! !


!OomMetricAbstract class methodsFor: 'reporting' stamp: 'nishis 5/17/98 21:25'!
report1: aDictionary 
	| aStream aModel |
	Cursor write showWhile: 
		[aStream := WriteStream on: (String new: 1024).
		self report1: aDictionary on: aStream.
		aModel := StringHolder new contents: aStream contents].
	StringHolderView
		open: aModel
		label: self name asString
		"extent: 300 @ 150"! !

!OomMetricAbstract class methodsFor: 'reporting' stamp: 'nishis 5/17/98 20:49'!
report1: aDictionary on: aStream 
	| sortBlock |
	aStream nextPutAll: self item; tab.
	aStream nextPutAll: self description; cr.
	sortBlock := [:a1 :a2 | (a1 key perform: self itemStringSelector)
				< (a2 key perform: self itemStringSelector)].
	((self associations: aDictionary) asSortedCollection: sortBlock)
		do: 
			[:assoc | 
			aStream nextPutAll: (assoc key perform: self itemStringSelector); tab.
			aStream nextPutAll: assoc value printString; cr]! !

!OomMetricAbstract class methodsFor: 'reporting' stamp: 'nishis 5/17/98 21:25'!
report2: aDictionary 
	| aStream aModel |
	Cursor write showWhile: 	
		[aStream := WriteStream on: (String new: 1024).
		self report2: aDictionary on: aStream.
		aModel := StringHolder new contents: aStream contents].
	StringHolderView
		open: aModel
		label: self name asString
		"extent: 300 @ 150"! !

!OomMetricAbstract class methodsFor: 'reporting' stamp: 'nishis 5/17/98 20:48'!
report2: aDictionary on: aStream 
	| sortBlock |
	aStream nextPutAll: self description; tab.
	aStream nextPutAll: self item; cr.
	sortBlock := [:a1 :a2 | a1 value > a2 value].
	((self associations: aDictionary) asSortedCollection: sortBlock)
		do: 
			[:assoc | 
			aStream nextPutAll: assoc value printString; tab.
			aStream nextPutAll: (assoc key perform: self itemStringSelector); cr]! !

!OomMetricAbstract class methodsFor: 'reporting'!
report: aDictionary 
	self report1: aDictionary! !

!OomMetricAbstract class methodsFor: 'reporting'!
report: aDictionary on: aStream 
	self report1: aDictionary on: aStream! !


!OomMetricAbstract class methodsFor: 'saving' stamp: 'nishis 5/17/98 17:25'!
save
	"OomMetricAbstract save."

	| fileName classCollection aStream timeStamp |
	fileName := 'OomMtric.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!OomMetricAbstract class methodsFor: 'saving' stamp: 'nishis 5/17/98 18:13'!
saveClasses
	"OomMetricAbstract saveClasses."

	| patternCollection classCollection string something categories classCollections |
	patternCollection := #('Oom*').
	categories := SystemOrganization categories 
					select: [:each | each asString beginsWith: self system].
	classCollections := OrderedCollection new.
	categories 
		do: 
			[:aCategory | 
			classCollection := SystemOrganization superclassOrder: aCategory.
			classCollection := classCollection asOrderedCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
			classCollections addAll: classCollection].
	^ChangeSet superclassOrder: classCollections! !


!OomMetricAbstract class methodsFor: 'private' stamp: 'nishis 5/17/98 20:47'!
associations: aCollection
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!OomMetricAbstract class methodsFor: 'private' stamp: 'nishis 5/18/98 03:11'!
rootsOfTheWorld
	^(Smalltalk 
		select: 
			[:each | 
				(each isKindOf: Behavior) and: [each superclass == nil]]) asOrderedCollection! !


!OomMetricAbstract class methodsFor: 'converting' stamp: 'nishis 7/19/1998 14:06'!
convertToMatrix: aDictionary 
	| aCollection sortBlock aMatrix |
	aCollection := OrderedCollection new: aDictionary size + 2.
	aCollection add: self item asText allBold.
	aCollection add: self nickname asText allBold.
	sortBlock := [:a1 :a2 | (a1 key perform: self itemStringSelector)
				< (a2 key perform: self itemStringSelector)].
	((self associations: aDictionary) asSortedCollection: sortBlock)
		do: 
			[:assoc | 
			aCollection add: (assoc key perform: self itemStringSelector).
			aCollection add: assoc value].
	aMatrix := OomMatrix
				new: aDictionary size + 1
				by: 2
				collection: aCollection.
	^aMatrix! !
