'Oom010 (11/18/2001 8:36:22 am)'.!


OomMetricCK subclass: #OomMetricWMC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricWMC commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricWMC methodsFor: 'computing'!
compute
	"(OomMetricWMC classes: Magnitude withAllSubclasses) compute."

	^self computeWMCs! !

!OomMetricWMC methodsFor: 'computing'!
computeMethodComplexities
	"(OomMetricWMC classes: Magnitude withAllSubclasses) computeMethodComplexities."

	| aDictionary weight complexity |
	aDictionary := self computeMethodWeights.
	aDictionary do: [:collection | collection
			do: 
				[:assoc | 
				weight := assoc value.
				complexity := (weight / self class constantForComplexity) asFloat.
				assoc value: complexity]].
	^aDictionary! !

!OomMetricWMC methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:24'!
computeMethodWeights
	"(OomMetricWMC classes: Magnitude withAllSubclasses) computeMethodWeights."

	| targetClasses aDictionary count size messageSelectors aCollection byteSize |
	targetClasses := self behaviors.
	size := targetClasses size.
	aDictionary := IdentityDictionary new: targetClasses size.
	size <= 0 ifTrue: [^aDictionary].
	count := 0.
	size := targetClasses size.
	self interim value: count value: size.
	targetClasses
		do: 
			[:aClass | 
			messageSelectors := aClass selectors.
			aCollection := OrderedCollection new: messageSelectors size.
			messageSelectors
				do: 
					[:aSelector | 
					byteSize := self weightForMethod: (aClass compiledMethodAt: aSelector).
					aCollection add: aSelector -> byteSize].
			aDictionary at: aClass put: aCollection.
			count := count + 1.
			self interim value: count value: size].
	^aDictionary! !

!OomMetricWMC methodsFor: 'computing'!
computeWMCs
	"(OomMetricWMC classes: Magnitude withAllSubclasses) computeWMCs."

	| methodComplexities aDictionary wmc key weight |
	methodComplexities := self computeMethodComplexities.
	aDictionary := IdentityDictionary new: (methodComplexities size / 0.6) asInteger.
	methodComplexities
		associationsDo: 
			[:pair | 
			wmc := 0.
			pair value
				do: 
					[:assoc | 
					weight := assoc value.
					wmc := wmc + weight].
			key := pair key.
			key isMeta
				ifTrue: [key := key soleInstance name]
				ifFalse: [key := key name].
			(aDictionary includesKey: key)
				ifTrue: [aDictionary at: key put: wmc + (aDictionary at: key)]
				ifFalse: [aDictionary at: key put: wmc]].
	^aDictionary! !


!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 11/17/2001 13:52'!
byteSizeOfObject: anObject 
	"OomMetricWMC new byteSizeOfObject: (OrderedCollection new: 10)."
	"OomMetricWMC new byteSizeOfObject: (Array new: 10)."
	"OomMetricWMC new byteSizeOfObject: 123.4e."
	"OomMetricWMC new byteSizeOfObject: 123.4."
	"OomMetricWMC new byteSizeOfObject: 123."
	"OomMetricWMC new byteSizeOfObject: 123 / 456."
	"OomMetricWMC new byteSizeOfObject: $C."
	"OomMetricWMC new byteSizeOfObject: #Smalltalk."

	"ex) see below
	Browser fullOnClass: SystemDictionary selector: #printSpaceAnalysis:on:.
	"

	| aClass baseHeaderSize objectHeadersSize bytesInOOP instVarFieldSize indexableFieldSize byteSize |

	"see Purple or Blue Book, pp.115, 441 (565 at Blue Book)"
	"
	SmallIntegers are immediate.  Characters are not, but there are only 256
	of them which are shared, so their space is effectively 0.
 	"
	"
	Small integers are immediate. Characters are shared
	references to one of a set of 256 Character objects.
	String elements are, of course, a single byte, which
	is used as an index into the 256 Character table.
	"
	aClass := anObject class.
	((aClass == SmallInteger) or: [aClass == Character]) ifTrue: [^0].
	"Object headers can be 1, 2, or 3 words (4, 8, or 12 bytes)."
	baseHeaderSize := self baseHeaderSize.
	objectHeadersSize := aClass indexIfCompact > 0 
				ifTrue: [baseHeaderSize] 
				ifFalse: 
					[((self sizeInWordsOf: anObject) + 1 ) > 16r3F
						ifTrue: [baseHeaderSize * 3]
						ifFalse: [baseHeaderSize * 2]].
	bytesInOOP := aClass isBytes ifTrue: [1] ifFalse: [4].

	"see Smalltalk-Idioms, pp. 84-92, Purple or Blue Book, pp.280-281"
	aClass isPointers
		ifTrue: 
			[instVarFieldSize := aClass instSize * bytesInOOP.
			aClass isVariable
				ifTrue: 
					[indexableFieldSize := anObject basicSize * bytesInOOP]
				ifFalse: 
					[indexableFieldSize := 0]]
		ifFalse: 
			[instVarFieldSize := 0.
			aClass isVariable
				ifTrue: 
					["Browser fullOnClass: RupaInvestigator selector: #weightForMethod:."
					indexableFieldSize := (anObject basicSize + 3) bitAnd: 16r1FFFFFFC]
				ifFalse: 
					["never fall down here"
					indexableFieldSize := 0]].
	"Squeak doesn't have an object table, so no space for that "
	byteSize := objectHeadersSize + instVarFieldSize + indexableFieldSize.
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 10/20/1998 22:53'!
byteSizeOfObject: anObject and: aCollection 
	"OomMetricWMC new byteSizeOfObject: 0 @ 1.23 and: #('x' 'y')."

	| visitedObjects byteSize index size object |
	visitedObjects := IdentitySet new.
	visitedObjects add: anObject.
	byteSize := self byteSizeOfObject: anObject.
	aCollection
		do: 
			[:instVarName | 
			index := self instVarIndex: anObject instVarName: instVarName.
			object := anObject instVarAt: index.
			((visitedObjects includes: object) not and: [self shouldCountObject: object])
				ifTrue: 
					[size := self byteSizeOfObject: object.
					visitedObjects add: object]
				ifFalse: [size := 0].
			byteSize := byteSize + size].
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing'!
byteSizeOfObjectsIn: anObject 
	"OomMetricWMC new byteSizeOfObjectsIn: 0 @ 1.23."

	| aClass visitedObjects byteSize object |
	aClass := anObject class.
	visitedObjects := IdentitySet new.
	visitedObjects add: anObject.
	byteSize := 0.
	1 to: aClass instSize
		do: 
			[:index | 
			object := anObject instVarAt: index.
			((visitedObjects includes: object) not and: [self shouldCountObject: object])
				ifTrue: 
					[byteSize := byteSize + (self byteSizeOfObject: object).
					visitedObjects add: object]].
	aClass isVariable ifTrue: [1 to: anObject basicSize
			do: 
				[:index | 
				object := anObject basicAt: index.
				((visitedObjects includes: object) not and: [self shouldCountObject: object])
					ifTrue: 
						[byteSize := byteSize + (self byteSizeOfObject: object).
						visitedObjects add: object]]].
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 11/13/1998 17:29'!
weightForClass: aClass 
	"OomMetricWMC new weightForClass: Point."
	"OomMetricWMC new weightForClass: OomMetricWMC."
	"OomMetricWMC new weightForClass: HtmlBiggerFontEntity."

	| theClass byteSize index |
	aClass isMeta
		ifTrue: [theClass := aClass soleInstance]
		ifFalse: [theClass := aClass].
	byteSize := self byteSizeOfObject: theClass and: #('subclasses' 'name' 'sharedPools').
	index := self instVarIndex: theClass instVarName: 'methodDict'.
	byteSize := byteSize + (self weightForMethodDictionary: (theClass instVarAt: index)).
	index := self instVarIndex: theClass instVarName: 'instanceVariables'.
	byteSize := byteSize + (self weightForObject: (theClass instVarAt: index)).
	index := self instVarIndex: theClass instVarName: 'organization'.
	byteSize := byteSize + (self weightForObject: (theClass instVarAt: index)).
	index := self instVarIndex: theClass instVarName: 'classPool'.
	byteSize := byteSize + (self weightForObject: (theClass instVarAt: index)).
	theClass := theClass class.
	byteSize := byteSize + (self byteSizeOfObject: theClass and: #('subclasses')).
	index := self instVarIndex: theClass instVarName: 'methodDict'.
	byteSize := byteSize + (self weightForMethodDictionary: (theClass instVarAt: index)).
	index := self instVarIndex: theClass instVarName: 'instanceVariables'.
	byteSize := byteSize + (self weightForObject: (theClass instVarAt: index)).
	index := self instVarIndex: theClass instVarName: 'organization'.
	byteSize := byteSize + (self weightForObject: (theClass instVarAt: index)).
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 11/12/1998 23:54'!
weightForLiteral: aLiteral 
	| literalClass |
	literalClass := aLiteral class.
	literalClass == Array ifTrue: [^self weightForLiteralArray: aLiteral].
	(literalClass == Symbol or: [(literalClass == SmallInteger)])
		ifFalse: [^self byteSizeOfObject: aLiteral].
	^0! !

!OomMetricWMC methodsFor: 'weighing'!
weightForLiteralArray: anArray 
	| byteSize |
	byteSize := self byteSizeOfObject: anArray.
	1 to: anArray size do: [:index | byteSize := byteSize + (self weightForLiteral: (anArray at: index))].
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 11/12/1998 23:55'!
weightForMethod: aMethod 
	"OomMetricWMC new weightForMethod: (Point compiledMethodAt: #x)."
	"OomMetricWMC new weightForMethod: (OomMetricWMC compiledMethodAt: #weightForMethod:)."

	"ex) see below
	Browser fullOnClass: ClassDescription selector: #spaceUsed.
	"
	"
    The response to size is the method size in bytes, including the method header, the
    literal frame, the bytecodes and the 4-byte sourcecode pointer at the end.
	"

	| byteSize objectHeadersSize size |
	objectHeadersSize := 4.
	"
	ex) see below
	inc := (size + 3) bitAnd: 16r1FFFFFFC.
	from
	Browser fullOnClass: ObjectMemory selector: #instantiateClass:indexableSize:.
	"
	byteSize := (aMethod size + 3) bitAnd: 16r1FFFFFFC.
	byteSize := byteSize + objectHeadersSize.
	aMethod
		literals do: 
			[:literal | 
			size := self weightForLiteral: literal.
			byteSize := byteSize + size].
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 11/4/1998 23:53'!
weightForMethodDictionary: aMethodDictionary 
	"OomMetricWMC new weightForMethodDictionary: Point copyOfMethodDictionary."
	"OomMetricWMC new weightForMethodDictionary: OomMetricWMC copyOfMethodDictionary."

	| byteSize size |
	byteSize := self byteSizeOfObject: aMethodDictionary and: #('array').
	aMethodDictionary
		do: 
			[:method | 
			size := self weightForMethod: method.
			byteSize := byteSize + size].
	^byteSize! !

!OomMetricWMC methodsFor: 'weighing' stamp: 'nishis 9/7/1998 21:42'!
weightForObject: anObject 
	"OomMetricWMC new weightForObject: Point fromUser."
	"OomMetricWMC new weightForObject: (Point x: 0 y: 0)."

	(self shouldCountObject: anObject)
		ifFalse: [^0].
	^(self byteSizeOfObject: anObject)
		+ (self byteSizeOfObjectsIn: anObject)! !


!OomMetricWMC methodsFor: 'private' stamp: 'nishis 11/17/2001 13:58'!
baseHeaderSize
	^ self class baseHeaderSize! !

!OomMetricWMC methodsFor: 'private' stamp: 'nishis 7/17/1998 15:07'!
bytes: aCompiledMethod
	| byteArray index |
	byteArray := ByteArray new: (aCompiledMethod endPC - aCompiledMethod initialPC + 1).
	index := 1.
	aCompiledMethod initialPC to: aCompiledMethod endPC do:
		[:bytecode | byteArray at: index put: (aCompiledMethod at: bytecode).
		index := index + 1].
	^byteArray
! !

!OomMetricWMC methodsFor: 'private' stamp: 'nishis 9/7/1998 21:40'!
instVarIndex: anObject instVarName: instVarName 
	"Investigator new instVarIndex: Point zero instVarName: #y."
	"OomMetricWMC new instVarIndex: (Point x: 0 y: 0) instVarName: #y."

	| aClass instVarNames instVarIndex |
	aClass := anObject class.
	instVarNames := aClass allInstVarNames.
	instVarIndex := instVarNames findFirst: [:each | each asString = instVarName asString].
	^instVarIndex! !

!OomMetricWMC methodsFor: 'private'!
shouldCountObject: anObject 
	^(anObject == nil or: [anObject == true or: [anObject == false]]) not! !

!OomMetricWMC methodsFor: 'private' stamp: 'nishis 11/4/1998 08:43'!
sizeInWordsOf: anObject 
	"copied from SystemTracer>>sizeInWordsOf:"
"NOTE: This is the new length of the object in LONG WORDS.
		Does not include the class (header) word."
	| class |
	class _ anObject class.
	class isBytes ifTrue: [^ anObject basicSize+3 // 4].
	class isBits ifTrue: [^ anObject basicSize].	"in two byte chunks"
	class isVariable ifTrue: [^ class instSize + anObject basicSize].
	^ class instSize! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricWMC class
	instanceVariableNames: 'baseHeaderSize '!

!OomMetricWMC class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricWMC class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricWMC class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricWMC class methodsFor: 'initialize-release' stamp: 'nishis 11/17/2001 13:57'!
initialize
	"OomMetricWMC initialize."
	| aObjectMemoryClass |
	aObjectMemoryClass := Smalltalk at: #ObjectMemory ifAbsent: [].
	baseHeaderSize := aObjectMemoryClass isNil not
				ifTrue: [(aObjectMemoryClass classVarNames includes: #BaseHeaderSize)
						ifTrue: [aObjectMemoryClass classPool at: #BaseHeaderSize]
						ifFalse: [4]]
				ifFalse: [4]! !


!OomMetricWMC class methodsFor: 'accessing' stamp: 'nishis 11/17/2001 13:57'!
baseHeaderSize
	^ baseHeaderSize! !


!OomMetricWMC class methodsFor: 'description'!
description
	^'weighted methods per class'! !

!OomMetricWMC class methodsFor: 'description'!
nickname
	^'WMC'! !


!OomMetricWMC class methodsFor: 'constants'!
constantForComplexity
	"128 is the average byte size of method weights."

	^128! !


!OomMetricWMC class methodsFor: 'examples'!
example1
	"OomMetricWMC example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricWMC classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricWMC class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:34'!
example2
	"OomMetricWMC example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricWMC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricWMC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:25'!
example3
	"OomMetricWMC example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricWMC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricWMC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:26'!
example4
	"OomMetricWMC example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricWMC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 200
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !


OomMetricWMC initialize!
