'Oom010 (11/18/2001 8:36:23 am)'.!


OomMetricBasic subclass: #OomMetricNOA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricNOA commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNOA methodsFor: 'computing'!
compute
	"(OomMetricNOA classes: Magnitude withAllSubclasses) compute."

	^self computeNOAs! !

!OomMetricNOA methodsFor: 'computing'!
computeNOA: aClass 
	"OomMetricNOA new computeNOA: Point."

	^aClass instVarNames size + aClass class instVarNames size + aClass classVarNames size! !

!OomMetricNOA methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:16'!
computeNOAs
	"(OomMetricNOA classes: Magnitude withAllSubclasses) computeNOAs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeNOA: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNOA class
	instanceVariableNames: ''!

!OomMetricNOA class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNOA class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNOA class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNOA class methodsFor: 'description'!
description
	^'number of attributes per class'! !

!OomMetricNOA class methodsFor: 'description'!
nickname
	^'NOA'! !


!OomMetricNOA class methodsFor: 'examples'!
example1
	"OomMetricNOA example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOA classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNOA class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:33'!
example2
	"OomMetricNOA example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOA classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNOA class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:16'!
example3
	"OomMetricNOA example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOA classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNOA class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:16'!
example4
	"OomMetricNOA example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOA classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 20
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
