'Oom010 (11/18/2001 8:36:23 am)'.!


OomMetricCK subclass: #OomMetricLCOM
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricLCOM commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricLCOM methodsFor: 'computing'!
compute
	"(OomMetricLCOM classes: Magnitude withAllSubclasses) compute."

	^self computeLCOMs! !

!OomMetricLCOM methodsFor: 'computing'!
computeLCOM: aClass 
	"OomMetricLCOM new computeLCOM: Point."

	| dictionary array aLCOM |
	dictionary := self computeUsedInstanceVariables: aClass.
	array := self computePQLCOM: dictionary.
	aLCOM := array at: 3.
	dictionary := self computeUsedInstanceVariables: aClass class.
	array := self computePQLCOM: dictionary.
	aLCOM := aLCOM + (array at: 3).
	^aLCOM! !

!OomMetricLCOM methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:21'!
computeLCOMs
	"(OomMetricLCOM classes: Magnitude withAllSubclasses) computeLCOMs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeLCOM: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricLCOM methodsFor: 'computing' stamp: 'nishis 5/17/98 20:48'!
computePQLCOM: aDictionary 
	"|P| = 9, |Q| = 1, LCOM = 8"
	"
	| dictionary array | 
	dictionary := Dictionary new. 
	dictionary at: #m1 put: #(#a). 
	dictionary at: #m2 put: #(#b). 
	dictionary at: #m3 put: #(#c). 
	dictionary at: #m4 put: #(#d). 
	dictionary at: #m5 put: #(#d #e). 
	array := OomMetricLCOM new computePQLCOM: dictionary. 
	Transcript cr; show: '|P| = ' , (array at: 1) printString. 
	Transcript cr; show: '|Q| = ' , (array at: 2) printString. 
	Transcript cr; show: 'LCOM = ' , (array at: 3) printString. 
	^array 
	"
	"|P| = 18, |Q| = 10, LCOM = 8"
	"
	| dictionary array | 
	dictionary := Dictionary new. 
	dictionary at: #m1 put: #(#a #c #e). 
	dictionary at: #m2 put: #(#b). 
	dictionary at: #m3 put: #(#b #c). 
	dictionary at: #m4 put: #(#c #d). 
	dictionary at: #m5 put: #(#d #e). 
	dictionary at: #m6 put: #(#e #f). 
	dictionary at: #m7 put: #(#f #g). 
	dictionary at: #m8 put: #(#a #h). 
	array := OomMetricLCOM new computePQLCOM: dictionary. 
	Transcript cr; show: '|P| = ' , (array at: 1) printString. 
	Transcript cr; show: '|Q| = ' , (array at: 2) printString. 
	Transcript cr; show: 'LCOM = ' , (array at: 3) printString. 
	^array 
	"
	"|P| = 3, |Q| = 3, LCOM = 0"
	"
	| dictionary array | 
	dictionary := Dictionary new. 
	dictionary at: #m1 put: #(#a #b #c #d #e). 
	dictionary at: #m2 put: #(#a #b #e). 
	dictionary at: #m3 put: #(#x #y #z). 
	dictionary at: #m4 put: #(#x #y #z #d). 
	array := OomMetricLCOM new computePQLCOM: dictionary. 
	Transcript cr; show: '|P| = ' , (array at: 1) printString. 
	Transcript cr; show: '|Q| = ' , (array at: 2) printString. 
	Transcript cr; show: 'LCOM = ' , (array at: 3) printString. 
	^array 
	"

	| countP countQ collection set1 set2 aLCOM result |
	countP := 0.
	countQ := 0.
	collection := (self associations: aDictionary) asSortedCollection asArray.
	(self indexPairs: collection size)
		do: 
			[:pair | 
			set1 := (collection at: pair first) value.
			set2 := (collection at: pair last) value.
			(set1 isEmpty and: [set2 isEmpty])
				ifFalse: [(self intersects: set1 with: set2)
						ifTrue: [countQ := countQ + 1]
						ifFalse: [countP := countP + 1]]].
	countP > countQ
		ifTrue: [aLCOM := countP - countQ]
		ifFalse: [aLCOM := 0].
	result := Array
				with: countP
				with: countQ
				with: aLCOM.
	^result! !

!OomMetricLCOM methodsFor: 'computing'!
computeUsedInstanceVariables: aClass 
	"OomMetricLCOM new computeUsedInstanceVariables: Point."

	| dictionary selectors |
	dictionary := IdentityDictionary new.
	aClass selectors do: [:selector | dictionary at: selector put: Set new].
	aClass allInstVarNames
		do: 
			[:each | 
			selectors := aClass whichSelectorsAccess: each.
			selectors do: [:selector | (dictionary includesKey: selector)
					ifTrue: [(dictionary at: selector)
							add: each]]].
	^dictionary! !


!OomMetricLCOM methodsFor: 'private'!
indexPairs: collectionSize 
	"OomMetricLCOM new indexPairs: 5."

	| size pairs |
	collectionSize > 2
		ifTrue: 
			[size := (collectionSize factorial / ((collectionSize - 2) factorial * 2 factorial)) asInteger.
			pairs := OrderedCollection new: size]
		ifFalse: [pairs := OrderedCollection new].
	1 to: collectionSize do: [:i | i + 1 to: collectionSize do: [:j | i = j ifFalse: [pairs add: (Array with: i with: j)]]].
	^pairs! !

!OomMetricLCOM methodsFor: 'private'!
intersects: set1 with: set2 
	set1 do: [:each | (set2 includes: each)
			ifTrue: [^true]].
	^false! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricLCOM class
	instanceVariableNames: ''!

!OomMetricLCOM class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricLCOM class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricLCOM class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricLCOM class methodsFor: 'description'!
description
	^'lack of cohesion of methods'! !

!OomMetricLCOM class methodsFor: 'description'!
nickname
	^'LCOM'! !


!OomMetricLCOM class methodsFor: 'examples'!
example1
	"OomMetricLCOM example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLCOM classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricLCOM class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:34'!
example2
	"OomMetricLCOM example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLCOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricLCOM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:21'!
example3
	"OomMetricLCOM example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLCOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricLCOM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:21'!
example4
	"OomMetricLCOM example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLCOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 500
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
