'Oom010 (11/18/2001 8:36:24 am)'.!


OomMetricBasic subclass: #OomMetricLOC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricLOC commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricLOC methodsFor: 'computing'!
compute
	"(OomMetricLOC classes: Magnitude withAllSubclasses) compute."

	^self computeLOCs! !

!OomMetricLOC methodsFor: 'computing'!
computeDefinitionLOC: aClass 
	"OomMetricLOC new computeDefinitionLOC: Point."

	| aStream |
	Cursor read showWhile: [aStream := ReadStream on: aClass definition asString].
	^(self getLines: aStream) size! !

!OomMetricLOC methodsFor: 'computing'!
computeLOC: aClass 
	"OomMetricLOC new computeLOC: Point."

	| theClass metaClass numberOfLines |
	aClass isMeta
		ifTrue: 
			[theClass := aClass soleInstance.
			metaClass := aClass class]
		ifFalse: 
			[theClass := aClass.
			metaClass := aClass class].
	numberOfLines := 0.
	numberOfLines := numberOfLines + (self computeDefinitionLOC: theClass).
	theClass selectors do: [:selector | numberOfLines := numberOfLines + (self computeMethodLOC: theClass selector: selector)].
	numberOfLines := numberOfLines + (self computeDefinitionLOC: metaClass).
	metaClass selectors do: [:selector | numberOfLines := numberOfLines + (self computeMethodLOC: metaClass selector: selector)].
	^numberOfLines! !

!OomMetricLOC methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:14'!
computeLOCs
	"(OomMetricLOC classes: Magnitude withAllSubclasses) computeLOCs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeLOC: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricLOC methodsFor: 'computing'!
computeMethodLOC: aClass selector: aSelector 
	"
	OomMetricLOC new 
		computeMethodLOC: Point 
		selector: #translatedBy:.
	"

	| aStream |
	Cursor read showWhile: [aStream := ReadStream on: (aClass sourceCodeAt: aSelector) asString].
	^(self getLines: aStream) size! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricLOC class
	instanceVariableNames: ''!

!OomMetricLOC class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricLOC class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricLOC class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricLOC class methodsFor: 'description'!
description
	^'lines of code'! !

!OomMetricLOC class methodsFor: 'description'!
nickname
	^'LOC'! !


!OomMetricLOC class methodsFor: 'examples'!
example1
	"OomMetricLOC example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLOC classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricLOC class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:27'!
example2
	"OomMetricLOC example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricLOC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:14'!
example3
	"OomMetricLOC example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricLOC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:15'!
example4
	"OomMetricLOC example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricLOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 1000
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
