'Oom010 (11/18/2001 8:36:24 am)'.!


OomMetricAoki subclass: #OomMetricRF
	instanceVariableNames: 'scope references order '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Aoki'!
!OomMetricRF commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricRF methodsFor: 'accessing'!
classes: classCollection 
	self classes == self scope
		ifTrue: 
			[scope := nil.
			references := nil.
			order := nil].
	super classes: classCollection! !

!OomMetricRF methodsFor: 'accessing'!
order
	order isNil ifTrue: [order := self topologicalSort: self references].
	^order! !

!OomMetricRF methodsFor: 'accessing'!
references
	references isNil ifTrue: [references := self computeReferences].
	^references! !

!OomMetricRF methodsFor: 'accessing'!
scope
	scope isNil ifTrue: [scope := self classes].
	^scope! !

!OomMetricRF methodsFor: 'accessing'!
scope: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	scope := collection.
	references := nil.
	order := nil! !


!OomMetricRF methodsFor: 'computing'!
compute
	"(OomMetricRF classes: Magnitude withAllSubclasses) compute."

	^self computeRFs! !

!OomMetricRF methodsFor: 'computing'!
computeRF: aClass 
	"(OomMetricRF classes: Magnitude withAllSubclasses) computeRF: Float."

	| index all aRF |
	index := (all := self order) indexOf: aClass name asSymbol.
	aRF := (index / all size) asFloat.
	^aRF! !

!OomMetricRF methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:10'!
computeRFs
	"(OomMetricRF classes: Magnitude withAllSubclasses) computeRFs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeRF: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricRF methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:11'!
computeReferences
	"(OomMetricRF classes: Magnitude withAllSubclasses) computeReferences."

	| size targets dictionary count |
	size := (targets := self scope) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^Array new].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name asSymbol -> (self computeReferences: each).
			count := count + 1.
			self interim value: count value: size].
	^(self associations: dictionary) asSortedCollection asArray! !

!OomMetricRF methodsFor: 'computing'!
computeReferences: aClass 
	"OomMetricRF new computeReferences: OomMetricRF."

	| set refs |
	set := IdentitySet new.
	aClass selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass selector: selector.
			refs do: [:each | set add: each]].
	aClass class selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass class selector: selector.
			refs do: [:each | set add: each]].
	^set asSortedCollection asArray! !

!OomMetricRF methodsFor: 'computing' stamp: 'nishis 7/23/1998 19:31'!
computeReferences: aClass selector: aSelector 
	"OomMetricRF new 
		computeReferences: OomMetricRF 
		selector: #computeReferences:selector:."

	| set one stream line tokens index token it |
	set := Set new.
	aClass isMeta
		ifTrue: [one := aClass soleInstance]
		ifFalse: [one := aClass].
	self
		withAllBlockMethodsDo:  
			[:method | 
			stream := ReadStream on: method symbolic.
			[stream atEnd]
				whileFalse: 
					[line := self getLine: stream.
					tokens := self separate: line dividers: self separators.
					"index := tokens findFirst: [:each | each = 'push']."
					index := tokens findFirst: [:each | each = 'pushLit:'].
					(index ~= 0 and: [tokens size = (index + 1)])
						ifTrue: 
							[token := tokens at: index + 1.
							((((token first isUppercase and: [Smalltalk includesKey: token asSymbol])
								and: [(it := Smalltalk at: token asSymbol) isKindOf: Behavior])
								and: [it isMeta not])
								and: [it ~~ one])
								ifTrue: [set add: it name asSymbol]]]]
		with: (aClass compiledMethodAt: aSelector).
	^set! !


!OomMetricRF methodsFor: 'private'!
topologicalSort: adjacencyArray 
	"OomMetricRF new topologicalSort: 
	((OomMetricRF classes: Magnitude withAllSubclasses) computeReferences)."

	| beenHeres adjacencyTable resultCollection |
	beenHeres := Dictionary new.
	adjacencyTable := Dictionary new.
	adjacencyArray
		do: 
			[:assoc | 
			beenHeres at: assoc key put: #never.
			adjacencyTable add: assoc].
	resultCollection := OrderedCollection new: adjacencyArray size.
	(adjacencyArray collect: [:assoc | assoc key])
		do: [:each | self
				topologicalVisit: each
				adjacencyTable: adjacencyTable
				beenHeres: beenHeres
				into: resultCollection].
	^resultCollection asArray! !

!OomMetricRF methodsFor: 'private'!
topologicalVisit: currentObject adjacencyTable: adjacencyTable beenHeres: beenHeres into: resultCollection 
	| adjacencies beenHere |
	(beenHeres at: currentObject)
		= #never ifTrue: [beenHeres at: currentObject put: #just].
	adjacencies := adjacencyTable at: currentObject.
	adjacencies
		do: 
			[:each | 
			beenHere := beenHeres at: each ifAbsent: [nil].
			beenHere = #never ifTrue: [self
					topologicalVisit: each
					adjacencyTable: adjacencyTable
					beenHeres: beenHeres
					into: resultCollection].
			beenHere = #just ifTrue: [#just yourself].
			beenHere = #once ifTrue: [#once yourself]].
	((beenHeres at: currentObject)
		= #once) not
		ifTrue: 
			[resultCollection addLast: currentObject.
			beenHeres at: currentObject put: #once].
	^resultCollection! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricRF class
	instanceVariableNames: ''!

!OomMetricRF class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricRF class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricRF class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricRF class methodsFor: 'description'!
description
	^'reference factor'! !

!OomMetricRF class methodsFor: 'description'!
nickname
	^'RF'! !


!OomMetricRF class methodsFor: 'examples'!
example1
	"OomMetricRF example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRF classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricRF class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:26'!
example2
	"OomMetricRF example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRF classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricRF class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:25'!
example3
	"OomMetricRF example3."

	| classes calculator progress animator result matrix table collection |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRF classes: classes.
	collection := Collection withAllSubclasses asOrderedCollection.
	collection addAll: Magnitude withAllSubclasses.
	calculator scope: collection.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !
