'Oom010 (11/18/2001 8:36:25 am)'.!


OomMetricAoki subclass: #OomMetricCP
	instanceVariableNames: 'scope references '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Aoki'!
!OomMetricCP commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricCP methodsFor: 'accessing'!
classes: classCollection 
	self classes == self scope
		ifTrue: 
			[scope := nil.
			references := nil].
	super classes: classCollection! !

!OomMetricCP methodsFor: 'accessing'!
references
	references isNil ifTrue: [references := self computeReferences].
	^references! !

!OomMetricCP methodsFor: 'accessing'!
scope
	scope isNil ifTrue: [scope := self classes].
	^scope! !

!OomMetricCP methodsFor: 'accessing'!
scope: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	scope := collection.
	references := nil! !


!OomMetricCP methodsFor: 'computing'!
compute
	"(OomMetricCP classes: Magnitude withAllSubclasses) compute."

	^self computeCPs! !

!OomMetricCP methodsFor: 'computing' stamp: 'nishis 5/17/98 22:10'!
computeCP: aClass 
	| aCP referenceCount |
	aCP := 0.
	(self values: self references)
		do: 
			[:dictionary | 
			referenceCount := dictionary at: aClass ifAbsent: [nil].
			referenceCount notNil ifTrue: [aCP := aCP + referenceCount]].
	^aCP! !

!OomMetricCP methodsFor: 'computing'!
computeCPs
	"(OomMetricCP classes: Magnitude withAllSubclasses) computeCPs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeCP: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricCP methodsFor: 'computing'!
computeReferences
	"(OomMetricCP classes: Magnitude withAllSubclasses) computeReferences."

	| size targets dictionary count |
	size := (targets := self scope) size.
	dictionary := IdentityDictionary new: size.
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each -> (self computeReferences: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricCP methodsFor: 'computing'!
computeReferences: aClass 
	"OomMetricCP new computeReferences: OomMetricCP."

	| dictionary refs |
	dictionary := IdentityDictionary new.
	aClass selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass selector: selector.
			refs do: [:each | (dictionary includesKey: each)
					ifTrue: [dictionary add: each -> (1 + (dictionary at: each))]
					ifFalse: [dictionary add: each -> 1]]].
	aClass class selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass class selector: selector.
			refs do: [:each | (dictionary includesKey: each)
					ifTrue: [dictionary add: each -> (1 + (dictionary at: each))]
					ifFalse: [dictionary add: each -> 1]]].
	^dictionary! !

!OomMetricCP methodsFor: 'computing' stamp: 'nishis 5/17/98 22:49'!
computeReferences: aClass selector: aSelector 
	"[OomMetricCP new 
		computeReferences: OomMetricCP 
		selector: #computeReferences:selector:.] method symbolic"

	| bag one stream line tokens index token it |
	bag := Bag new.
	aClass isMeta
		ifTrue: [one := aClass soleInstance]
		ifFalse: [one := aClass].
	self
		withAllBlockMethodsDo:  
			[:method | 
			stream := ReadStream on: method symbolic.
			[stream atEnd]
				whileFalse: 
					[line := self getLine: stream.
					tokens := self separate: line dividers: self separators.
					"index := tokens findFirst: [:each | each = 'push']."
					index := tokens findFirst: [:each | each = 'pushLit:'].
					(index ~= 0 and: [tokens size = (index + 1)])
						ifTrue: 
							[token := tokens at: index + 1.
							((((token first isUppercase and: [Smalltalk includesKey: token asSymbol])
								and: [(it := Smalltalk at: token asSymbol) isKindOf: Behavior])
								and: [it isMeta not])
								and: [it ~~ one])
								ifTrue: [bag add: it]]]]
		with: (aClass compiledMethodAt: aSelector).
	^bag! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricCP class
	instanceVariableNames: ''!

!OomMetricCP class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricCP class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricCP class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricCP class methodsFor: 'description'!
description
	^'class popularity'! !

!OomMetricCP class methodsFor: 'description'!
nickname
	^'CP'! !


!OomMetricCP class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:25'!
example1
	"OomMetricCP example1."

	| classes calculator animator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCP classes: classes.
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [result := calculator compute].
	calculator report: result.
	^result! !

!OomMetricCP class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:25'!
example2
	"OomMetricCP example2."

	| classes calculator progress animator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCP classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	calculator report2: result.
	^result! !
