'Oom010 (11/18/2001 8:36:25 am)'.!


OomMetricAoki subclass: #OomMetricHF
	instanceVariableNames: 'scope '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Aoki'!
!OomMetricHF commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricHF methodsFor: 'accessing'!
classes: classCollection 
	self classes == self scope ifTrue: [scope := nil].
	super classes: classCollection! !

!OomMetricHF methodsFor: 'accessing'!
scope
	scope isNil ifTrue: [scope := self classes].
	^scope! !

!OomMetricHF methodsFor: 'accessing'!
scope: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	scope := collection! !


!OomMetricHF methodsFor: 'computing'!
compute
	"(OomMetricHF classes: Magnitude withAllSubclasses) compute."

	^self computeHFs! !

!OomMetricHF methodsFor: 'computing'!
computeHF: aClass 
	"OomMetricHF new computeHF: OomMetricAoki."

	| denominator numerator aHF |
	denominator := numerator := aClass allSuperclasses size.
	denominator := denominator + 1.
	denominator := denominator + (aClass allSubclasses select: [:each | self scope includes: each]) size.
	aHF := (numerator / denominator) asFloat.
	^aHF! !

!OomMetricHF methodsFor: 'computing'!
computeHFs
	"(OomMetricHF classes: Magnitude withAllSubclasses) computeHFs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeHF: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricHF class
	instanceVariableNames: ''!

!OomMetricHF class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricHF class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricHF class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricHF class methodsFor: 'description'!
description
	^'hierarchy factor'! !

!OomMetricHF class methodsFor: 'description'!
nickname
	^'HF'! !


!OomMetricHF class methodsFor: 'examples'!
example1
	"OomMetricHF example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricHF classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricHF class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:24'!
example2
	"OomMetricHF example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricHF classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricHF class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example3
	"OomMetricHF example3."

	| classes calculator progress animator result matrix table collection |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricHF classes: classes.
	collection := Collection withAllSubclasses asOrderedCollection.
	collection addAll: Magnitude withAllSubclasses.
	calculator scope: collection.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !
