'Oom010 (11/18/2001 8:36:25 am)'.!


OomMetricCK subclass: #OomMetricCBO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricCBO commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricCBO methodsFor: 'computing'!
compute
	"(OomMetricCBO classes: Magnitude withAllSubclasses) compute."

	^self computeCBOs! !

!OomMetricCBO methodsFor: 'computing'!
computeCBO: aClass 
	"OomMetricCBO new computeCBO: Point."

	| set |
	set := Set new.
	set addAll: (self computeReferences: aClass).
	set addAll: (self computeReferences: aClass class).
	^set size! !

!OomMetricCBO methodsFor: 'computing' stamp: 'nishis 10/7/1998 23:41'!
computeCBOs
	"(OomMetricCBO classes: Magnitude withAllSubclasses) computeCBOs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeCBO: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricCBO methodsFor: 'computing' stamp: 'nishis 10/7/1998 23:17'!
computeReferences: aClass 
	"OomMetricCBO new computeReferences: Point."

	| set literals |
	set := Set new.
	aClass selectors
		do: 
			[:selector | 
			literals := self allLiterals: (aClass compiledMethodAt: selector).
			literals do: [:literal | ((((self isVariableBinding: literal) and: [literal value isKindOf: Behavior])
					and: [literal value isMeta not]) and: [literal key notNil])
					ifTrue: [set add: literal key]]].
	^set! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricCBO class
	instanceVariableNames: ''!

!OomMetricCBO class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricCBO class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricCBO class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricCBO class methodsFor: 'description'!
description
	^'coupling between objects'! !

!OomMetricCBO class methodsFor: 'description'!
nickname
	^'CBO'! !


!OomMetricCBO class methodsFor: 'examples'!
example1
	"OomMetricCBO example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCBO classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricCBO class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:33'!
example2
	"OomMetricCBO example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCBO classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricCBO class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:19'!
example3
	"OomMetricCBO example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCBO classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricCBO class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:20'!
example4
	"OomMetricCBO example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricCBO classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 20
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
