'Oom010 (11/18/2001 8:36:26 am)'.!


OomMetricCK subclass: #OomMetricRFC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricRFC commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricRFC methodsFor: 'computing'!
compute
	"(OomMetricRFC classes: Magnitude withAllSubclasses) compute."

	^self computeRFCs! !

!OomMetricRFC methodsFor: 'computing'!
computeRFC: aClass 
	"OomMetricRFC new computeRFC: Point."

	| set |
	set := Set new.
	set addAll: (self computeResponses: aClass).
	set addAll: (self computeResponses: aClass class).
	^set size! !

!OomMetricRFC methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:22'!
computeRFCs
	"(OomMetricRFC classes: Magnitude withAllSubclasses) computeRFCs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeRFC: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricRFC methodsFor: 'computing'!
computeResponses: aClass 
	"OomMetricRFC new computeResponses: Point."

	| set |
	set := Set new.
	aClass selectors
		do: 
			[:selector | 
			set add: selector.
			set addAll: (aClass compiledMethodAt: selector) messages].
	^set! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricRFC class
	instanceVariableNames: ''!

!OomMetricRFC class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricRFC class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricRFC class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricRFC class methodsFor: 'description'!
description
	^'response for a class'! !

!OomMetricRFC class methodsFor: 'description'!
nickname
	^'RFC'! !


!OomMetricRFC class methodsFor: 'examples'!
example1
	"OomMetricRFC example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRFC classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricRFC class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:34'!
example2
	"OomMetricRFC example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRFC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricRFC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:23'!
example3
	"OomMetricRFC example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRFC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricRFC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:23'!
example4
	"OomMetricRFC example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricRFC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 200
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
