'Oom010 (11/18/2001 8:36:27 am)'.!


OomMetricAoki subclass: #OomMetricPF
	instanceVariableNames: 'scope messages '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Aoki'!
!OomMetricPF commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricPF methodsFor: 'accessing'!
classes: classCollection 
	self classes == self scope
		ifTrue: 
			[scope := nil.
			messages := nil].
	super classes: classCollection! !

!OomMetricPF methodsFor: 'accessing'!
messages
	messages isNil ifTrue: [messages := self computeMessages].
	^messages! !

!OomMetricPF methodsFor: 'accessing'!
scope
	scope isNil ifTrue: [scope := self classes].
	^scope! !

!OomMetricPF methodsFor: 'accessing'!
scope: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	scope := collection.
	messages := nil! !


!OomMetricPF methodsFor: 'computing'!
compute
	"(OomMetricPF classes: Magnitude withAllSubclasses) compute."

	^self computePFs! !

!OomMetricPF methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:08'!
computeMessages
	| size targets bag count |
	size := (targets := self scope) size.
	bag := Bag new.
	size <= 0 ifTrue: [^bag].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			bag addAll: each selectors.
			bag addAll: each class selectors.
			count := count + 1.
			self interim value: count value: size].
	^bag! !

!OomMetricPF methodsFor: 'computing'!
computePF: aClass 
	"OomMetricPF new computePF: Point."

	| selectors count all aPF |
	selectors := Bag new.
	selectors addAll: aClass selectors.
	selectors addAll: aClass class selectors.
	count := 0.
	all := 0.
	selectors asSet
		do: 
			[:each | 
			(self messages occurrencesOf: each)
				> (selectors occurrencesOf: each) ifTrue: [count := count + 1].
			all := all + 1].
	all <= 0
		ifTrue: [aPF := 0]
		ifFalse: [aPF := (count / all) asFloat].
	^aPF! !

!OomMetricPF methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:09'!
computePFs
	"(OomMetricPF classes: Magnitude withAllSubclasses) computePFs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computePF: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricPF class
	instanceVariableNames: ''!

!OomMetricPF class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricPF class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricPF class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricPF class methodsFor: 'description'!
description
	^'polymorphism factor'! !

!OomMetricPF class methodsFor: 'description'!
nickname
	^'PF'! !


!OomMetricPF class methodsFor: 'examples'!
example1
	"OomMetricPF example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricPF classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricPF class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:26'!
example2
	"OomMetricPF example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricPF classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricPF class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example3
	"OomMetricPF example3."

	| classes calculator progress animator result matrix table collection |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricPF classes: classes.
	collection := Collection withAllSubclasses asOrderedCollection.
	collection addAll: Magnitude withAllSubclasses.
	calculator scope: collection.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !
